function __$styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

import React__default, { createElement, Component, Fragment } from 'react';
import _propTypes from 'prop-types';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var mapToZero_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;
exports['default'] = mapToZero;

function mapToZero(obj) {
  var ret = {};
  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      ret[key] = 0;
    }
  }
  return ret;
}

module.exports = exports['default'];
});

unwrapExports(mapToZero_1);

var stripStyle_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;
exports['default'] = stripStyle;

function stripStyle(style) {
  var ret = {};
  for (var key in style) {
    if (!Object.prototype.hasOwnProperty.call(style, key)) {
      continue;
    }
    ret[key] = typeof style[key] === 'number' ? style[key] : style[key].val;
  }
  return ret;
}

module.exports = exports['default'];
});

unwrapExports(stripStyle_1);

var stepper_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;
exports["default"] = stepper;

var reusedTuple = [0, 0];

function stepper(secondPerFrame, x, v, destX, k, b, precision) {
  // Spring stiffness, in kg / s^2

  // for animations, destX is really spring length (spring at rest). initial
  // position is considered as the stretched/compressed position of a spring
  var Fspring = -k * (x - destX);

  // Damping, in kg / s
  var Fdamper = -b * v;

  // usually we put mass here, but for animation purposes, specifying mass is a
  // bit redundant. you could simply adjust k and b accordingly
  // let a = (Fspring + Fdamper) / mass;
  var a = Fspring + Fdamper;

  var newV = v + a * secondPerFrame;
  var newX = x + newV * secondPerFrame;

  if (Math.abs(newV) < precision && Math.abs(newX - destX) < precision) {
    reusedTuple[0] = destX;
    reusedTuple[1] = 0;
    return reusedTuple;
  }

  reusedTuple[0] = newX;
  reusedTuple[1] = newV;
  return reusedTuple;
}

module.exports = exports["default"];
// array reference around.
});

unwrapExports(stepper_1);

var performanceNow = createCommonjsModule(function (module) {
// Generated by CoffeeScript 1.7.1
(function() {
  var getNanoSeconds, hrtime, loadTime;

  if ((typeof performance !== "undefined" && performance !== null) && performance.now) {
    module.exports = function() {
      return performance.now();
    };
  } else if ((typeof process !== "undefined" && process !== null) && process.hrtime) {
    module.exports = function() {
      return (getNanoSeconds() - loadTime) / 1e6;
    };
    hrtime = process.hrtime;
    getNanoSeconds = function() {
      var hr;
      hr = hrtime();
      return hr[0] * 1e9 + hr[1];
    };
    loadTime = getNanoSeconds();
  } else if (Date.now) {
    module.exports = function() {
      return Date.now() - loadTime;
    };
    loadTime = Date.now();
  } else {
    module.exports = function() {
      return new Date().getTime() - loadTime;
    };
    loadTime = new Date().getTime();
  }

}).call(commonjsGlobal);
});

var performanceNow$1 = createCommonjsModule(function (module) {
// Generated by CoffeeScript 1.12.2
(function() {
  var getNanoSeconds, hrtime, loadTime, moduleLoadTime, nodeLoadTime, upTime;

  if ((typeof performance !== "undefined" && performance !== null) && performance.now) {
    module.exports = function() {
      return performance.now();
    };
  } else if ((typeof process !== "undefined" && process !== null) && process.hrtime) {
    module.exports = function() {
      return (getNanoSeconds() - nodeLoadTime) / 1e6;
    };
    hrtime = process.hrtime;
    getNanoSeconds = function() {
      var hr;
      hr = hrtime();
      return hr[0] * 1e9 + hr[1];
    };
    moduleLoadTime = getNanoSeconds();
    upTime = process.uptime() * 1e9;
    nodeLoadTime = moduleLoadTime - upTime;
  } else if (Date.now) {
    module.exports = function() {
      return Date.now() - loadTime;
    };
    loadTime = Date.now();
  } else {
    module.exports = function() {
      return new Date().getTime() - loadTime;
    };
    loadTime = new Date().getTime();
  }

}).call(commonjsGlobal);


});

var root = typeof window === 'undefined' ? commonjsGlobal : window
  , vendors = ['moz', 'webkit']
  , suffix = 'AnimationFrame'
  , raf = root['request' + suffix]
  , caf = root['cancel' + suffix] || root['cancelRequest' + suffix];

for(var i = 0; !raf && i < vendors.length; i++) {
  raf = root[vendors[i] + 'Request' + suffix];
  caf = root[vendors[i] + 'Cancel' + suffix]
      || root[vendors[i] + 'CancelRequest' + suffix];
}

// Some versions of FF have rAF but not cAF
if(!raf || !caf) {
  var last = 0
    , id = 0
    , queue = []
    , frameDuration = 1000 / 60;

  raf = function(callback) {
    if(queue.length === 0) {
      var _now = performanceNow$1()
        , next = Math.max(0, frameDuration - (_now - last));
      last = next + _now;
      setTimeout(function() {
        var cp = queue.slice(0);
        // Clear queue here to prevent
        // callbacks from appending listeners
        // to the current frame's queue
        queue.length = 0;
        for(var i = 0; i < cp.length; i++) {
          if(!cp[i].cancelled) {
            try{
              cp[i].callback(last);
            } catch(e) {
              setTimeout(function() { throw e }, 0);
            }
          }
        }
      }, Math.round(next));
    }
    queue.push({
      handle: ++id,
      callback: callback,
      cancelled: false
    });
    return id
  };

  caf = function(handle) {
    for(var i = 0; i < queue.length; i++) {
      if(queue[i].handle === handle) {
        queue[i].cancelled = true;
      }
    }
  };
}

var raf_1 = function(fn) {
  // Wrap in a new function to prevent
  // `cancel` potentially being assigned
  // to the native rAF function
  return raf.call(root, fn)
};
var cancel = function() {
  caf.apply(root, arguments);
};
var polyfill = function(object) {
  if (!object) {
    object = root;
  }
  object.requestAnimationFrame = raf;
  object.cancelAnimationFrame = caf;
};
raf_1.cancel = cancel;
raf_1.polyfill = polyfill;

var shouldStopAnimation_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;
exports['default'] = shouldStopAnimation;

function shouldStopAnimation(currentStyle, style, currentVelocity) {
  for (var key in style) {
    if (!Object.prototype.hasOwnProperty.call(style, key)) {
      continue;
    }

    if (currentVelocity[key] !== 0) {
      return false;
    }

    var styleValue = typeof style[key] === 'number' ? style[key] : style[key].val;
    // stepper will have already taken care of rounding precision errors, so
    // won't have such thing as 0.9999 !=== 1
    if (currentStyle[key] !== styleValue) {
      return false;
    }
  }

  return true;
}

module.exports = exports['default'];
});

unwrapExports(shouldStopAnimation_1);

var Motion_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }



var _mapToZero2 = _interopRequireDefault(mapToZero_1);



var _stripStyle2 = _interopRequireDefault(stripStyle_1);



var _stepper4 = _interopRequireDefault(stepper_1);



var _performanceNow2 = _interopRequireDefault(performanceNow);



var _raf2 = _interopRequireDefault(raf_1);



var _shouldStopAnimation2 = _interopRequireDefault(shouldStopAnimation_1);



var _react2 = _interopRequireDefault(React__default);



var _propTypes2 = _interopRequireDefault(_propTypes);

var msPerFrame = 1000 / 60;

var Motion = (function (_React$Component) {
  _inherits(Motion, _React$Component);

  _createClass(Motion, null, [{
    key: 'propTypes',
    value: {
      // TOOD: warn against putting a config in here
      defaultStyle: _propTypes2['default'].objectOf(_propTypes2['default'].number),
      style: _propTypes2['default'].objectOf(_propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].object])).isRequired,
      children: _propTypes2['default'].func.isRequired,
      onRest: _propTypes2['default'].func
    },
    enumerable: true
  }]);

  function Motion(props) {
    var _this = this;

    _classCallCheck(this, Motion);

    _React$Component.call(this, props);
    this.wasAnimating = false;
    this.animationID = null;
    this.prevTime = 0;
    this.accumulatedTime = 0;
    this.unreadPropStyle = null;

    this.clearUnreadPropStyle = function (destStyle) {
      var dirty = false;
      var _state = _this.state;
      var currentStyle = _state.currentStyle;
      var currentVelocity = _state.currentVelocity;
      var lastIdealStyle = _state.lastIdealStyle;
      var lastIdealVelocity = _state.lastIdealVelocity;

      for (var key in destStyle) {
        if (!Object.prototype.hasOwnProperty.call(destStyle, key)) {
          continue;
        }

        var styleValue = destStyle[key];
        if (typeof styleValue === 'number') {
          if (!dirty) {
            dirty = true;
            currentStyle = _extends({}, currentStyle);
            currentVelocity = _extends({}, currentVelocity);
            lastIdealStyle = _extends({}, lastIdealStyle);
            lastIdealVelocity = _extends({}, lastIdealVelocity);
          }

          currentStyle[key] = styleValue;
          currentVelocity[key] = 0;
          lastIdealStyle[key] = styleValue;
          lastIdealVelocity[key] = 0;
        }
      }

      if (dirty) {
        _this.setState({ currentStyle: currentStyle, currentVelocity: currentVelocity, lastIdealStyle: lastIdealStyle, lastIdealVelocity: lastIdealVelocity });
      }
    };

    this.startAnimationIfNecessary = function () {
      // TODO: when config is {a: 10} and dest is {a: 10} do we raf once and
      // call cb? No, otherwise accidental parent rerender causes cb trigger
      _this.animationID = _raf2['default'](function (timestamp) {
        // check if we need to animate in the first place
        var propsStyle = _this.props.style;
        if (_shouldStopAnimation2['default'](_this.state.currentStyle, propsStyle, _this.state.currentVelocity)) {
          if (_this.wasAnimating && _this.props.onRest) {
            _this.props.onRest();
          }

          // no need to cancel animationID here; shouldn't have any in flight
          _this.animationID = null;
          _this.wasAnimating = false;
          _this.accumulatedTime = 0;
          return;
        }

        _this.wasAnimating = true;

        var currentTime = timestamp || _performanceNow2['default']();
        var timeDelta = currentTime - _this.prevTime;
        _this.prevTime = currentTime;
        _this.accumulatedTime = _this.accumulatedTime + timeDelta;
        // more than 10 frames? prolly switched browser tab. Restart
        if (_this.accumulatedTime > msPerFrame * 10) {
          _this.accumulatedTime = 0;
        }

        if (_this.accumulatedTime === 0) {
          // no need to cancel animationID here; shouldn't have any in flight
          _this.animationID = null;
          _this.startAnimationIfNecessary();
          return;
        }

        var currentFrameCompletion = (_this.accumulatedTime - Math.floor(_this.accumulatedTime / msPerFrame) * msPerFrame) / msPerFrame;
        var framesToCatchUp = Math.floor(_this.accumulatedTime / msPerFrame);

        var newLastIdealStyle = {};
        var newLastIdealVelocity = {};
        var newCurrentStyle = {};
        var newCurrentVelocity = {};

        for (var key in propsStyle) {
          if (!Object.prototype.hasOwnProperty.call(propsStyle, key)) {
            continue;
          }

          var styleValue = propsStyle[key];
          if (typeof styleValue === 'number') {
            newCurrentStyle[key] = styleValue;
            newCurrentVelocity[key] = 0;
            newLastIdealStyle[key] = styleValue;
            newLastIdealVelocity[key] = 0;
          } else {
            var newLastIdealStyleValue = _this.state.lastIdealStyle[key];
            var newLastIdealVelocityValue = _this.state.lastIdealVelocity[key];
            for (var i = 0; i < framesToCatchUp; i++) {
              var _stepper = _stepper4['default'](msPerFrame / 1000, newLastIdealStyleValue, newLastIdealVelocityValue, styleValue.val, styleValue.stiffness, styleValue.damping, styleValue.precision);

              newLastIdealStyleValue = _stepper[0];
              newLastIdealVelocityValue = _stepper[1];
            }

            var _stepper2 = _stepper4['default'](msPerFrame / 1000, newLastIdealStyleValue, newLastIdealVelocityValue, styleValue.val, styleValue.stiffness, styleValue.damping, styleValue.precision);

            var nextIdealX = _stepper2[0];
            var nextIdealV = _stepper2[1];

            newCurrentStyle[key] = newLastIdealStyleValue + (nextIdealX - newLastIdealStyleValue) * currentFrameCompletion;
            newCurrentVelocity[key] = newLastIdealVelocityValue + (nextIdealV - newLastIdealVelocityValue) * currentFrameCompletion;
            newLastIdealStyle[key] = newLastIdealStyleValue;
            newLastIdealVelocity[key] = newLastIdealVelocityValue;
          }
        }

        _this.animationID = null;
        // the amount we're looped over above
        _this.accumulatedTime -= framesToCatchUp * msPerFrame;

        _this.setState({
          currentStyle: newCurrentStyle,
          currentVelocity: newCurrentVelocity,
          lastIdealStyle: newLastIdealStyle,
          lastIdealVelocity: newLastIdealVelocity
        });

        _this.unreadPropStyle = null;

        _this.startAnimationIfNecessary();
      });
    };

    this.state = this.defaultState();
  }

  Motion.prototype.defaultState = function defaultState() {
    var _props = this.props;
    var defaultStyle = _props.defaultStyle;
    var style = _props.style;

    var currentStyle = defaultStyle || _stripStyle2['default'](style);
    var currentVelocity = _mapToZero2['default'](currentStyle);
    return {
      currentStyle: currentStyle,
      currentVelocity: currentVelocity,
      lastIdealStyle: currentStyle,
      lastIdealVelocity: currentVelocity
    };
  };

  // it's possible that currentStyle's value is stale: if props is immediately
  // changed from 0 to 400 to spring(0) again, the async currentStyle is still
  // at 0 (didn't have time to tick and interpolate even once). If we naively
  // compare currentStyle with destVal it'll be 0 === 0 (no animation, stop).
  // In reality currentStyle should be 400

  Motion.prototype.componentDidMount = function componentDidMount() {
    this.prevTime = _performanceNow2['default']();
    this.startAnimationIfNecessary();
  };

  Motion.prototype.componentWillReceiveProps = function componentWillReceiveProps(props) {
    if (this.unreadPropStyle != null) {
      // previous props haven't had the chance to be set yet; set them here
      this.clearUnreadPropStyle(this.unreadPropStyle);
    }

    this.unreadPropStyle = props.style;
    if (this.animationID == null) {
      this.prevTime = _performanceNow2['default']();
      this.startAnimationIfNecessary();
    }
  };

  Motion.prototype.componentWillUnmount = function componentWillUnmount() {
    if (this.animationID != null) {
      _raf2['default'].cancel(this.animationID);
      this.animationID = null;
    }
  };

  Motion.prototype.render = function render() {
    var renderedChildren = this.props.children(this.state.currentStyle);
    return renderedChildren && _react2['default'].Children.only(renderedChildren);
  };

  return Motion;
})(_react2['default'].Component);

exports['default'] = Motion;
module.exports = exports['default'];

// after checking for unreadPropStyle != null, we manually go set the
// non-interpolating values (those that are a number, without a spring
// config)
});

unwrapExports(Motion_1);

var StaggeredMotion_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }



var _mapToZero2 = _interopRequireDefault(mapToZero_1);



var _stripStyle2 = _interopRequireDefault(stripStyle_1);



var _stepper4 = _interopRequireDefault(stepper_1);



var _performanceNow2 = _interopRequireDefault(performanceNow);



var _raf2 = _interopRequireDefault(raf_1);



var _shouldStopAnimation2 = _interopRequireDefault(shouldStopAnimation_1);



var _react2 = _interopRequireDefault(React__default);



var _propTypes2 = _interopRequireDefault(_propTypes);

var msPerFrame = 1000 / 60;

function shouldStopAnimationAll(currentStyles, styles, currentVelocities) {
  for (var i = 0; i < currentStyles.length; i++) {
    if (!_shouldStopAnimation2['default'](currentStyles[i], styles[i], currentVelocities[i])) {
      return false;
    }
  }
  return true;
}

var StaggeredMotion = (function (_React$Component) {
  _inherits(StaggeredMotion, _React$Component);

  _createClass(StaggeredMotion, null, [{
    key: 'propTypes',
    value: {
      // TOOD: warn against putting a config in here
      defaultStyles: _propTypes2['default'].arrayOf(_propTypes2['default'].objectOf(_propTypes2['default'].number)),
      styles: _propTypes2['default'].func.isRequired,
      children: _propTypes2['default'].func.isRequired
    },
    enumerable: true
  }]);

  function StaggeredMotion(props) {
    var _this = this;

    _classCallCheck(this, StaggeredMotion);

    _React$Component.call(this, props);
    this.animationID = null;
    this.prevTime = 0;
    this.accumulatedTime = 0;
    this.unreadPropStyles = null;

    this.clearUnreadPropStyle = function (unreadPropStyles) {
      var _state = _this.state;
      var currentStyles = _state.currentStyles;
      var currentVelocities = _state.currentVelocities;
      var lastIdealStyles = _state.lastIdealStyles;
      var lastIdealVelocities = _state.lastIdealVelocities;

      var someDirty = false;
      for (var i = 0; i < unreadPropStyles.length; i++) {
        var unreadPropStyle = unreadPropStyles[i];
        var dirty = false;

        for (var key in unreadPropStyle) {
          if (!Object.prototype.hasOwnProperty.call(unreadPropStyle, key)) {
            continue;
          }

          var styleValue = unreadPropStyle[key];
          if (typeof styleValue === 'number') {
            if (!dirty) {
              dirty = true;
              someDirty = true;
              currentStyles[i] = _extends({}, currentStyles[i]);
              currentVelocities[i] = _extends({}, currentVelocities[i]);
              lastIdealStyles[i] = _extends({}, lastIdealStyles[i]);
              lastIdealVelocities[i] = _extends({}, lastIdealVelocities[i]);
            }
            currentStyles[i][key] = styleValue;
            currentVelocities[i][key] = 0;
            lastIdealStyles[i][key] = styleValue;
            lastIdealVelocities[i][key] = 0;
          }
        }
      }

      if (someDirty) {
        _this.setState({ currentStyles: currentStyles, currentVelocities: currentVelocities, lastIdealStyles: lastIdealStyles, lastIdealVelocities: lastIdealVelocities });
      }
    };

    this.startAnimationIfNecessary = function () {
      // TODO: when config is {a: 10} and dest is {a: 10} do we raf once and
      // call cb? No, otherwise accidental parent rerender causes cb trigger
      _this.animationID = _raf2['default'](function (timestamp) {
        var destStyles = _this.props.styles(_this.state.lastIdealStyles);

        // check if we need to animate in the first place
        if (shouldStopAnimationAll(_this.state.currentStyles, destStyles, _this.state.currentVelocities)) {
          // no need to cancel animationID here; shouldn't have any in flight
          _this.animationID = null;
          _this.accumulatedTime = 0;
          return;
        }

        var currentTime = timestamp || _performanceNow2['default']();
        var timeDelta = currentTime - _this.prevTime;
        _this.prevTime = currentTime;
        _this.accumulatedTime = _this.accumulatedTime + timeDelta;
        // more than 10 frames? prolly switched browser tab. Restart
        if (_this.accumulatedTime > msPerFrame * 10) {
          _this.accumulatedTime = 0;
        }

        if (_this.accumulatedTime === 0) {
          // no need to cancel animationID here; shouldn't have any in flight
          _this.animationID = null;
          _this.startAnimationIfNecessary();
          return;
        }

        var currentFrameCompletion = (_this.accumulatedTime - Math.floor(_this.accumulatedTime / msPerFrame) * msPerFrame) / msPerFrame;
        var framesToCatchUp = Math.floor(_this.accumulatedTime / msPerFrame);

        var newLastIdealStyles = [];
        var newLastIdealVelocities = [];
        var newCurrentStyles = [];
        var newCurrentVelocities = [];

        for (var i = 0; i < destStyles.length; i++) {
          var destStyle = destStyles[i];
          var newCurrentStyle = {};
          var newCurrentVelocity = {};
          var newLastIdealStyle = {};
          var newLastIdealVelocity = {};

          for (var key in destStyle) {
            if (!Object.prototype.hasOwnProperty.call(destStyle, key)) {
              continue;
            }

            var styleValue = destStyle[key];
            if (typeof styleValue === 'number') {
              newCurrentStyle[key] = styleValue;
              newCurrentVelocity[key] = 0;
              newLastIdealStyle[key] = styleValue;
              newLastIdealVelocity[key] = 0;
            } else {
              var newLastIdealStyleValue = _this.state.lastIdealStyles[i][key];
              var newLastIdealVelocityValue = _this.state.lastIdealVelocities[i][key];
              for (var j = 0; j < framesToCatchUp; j++) {
                var _stepper = _stepper4['default'](msPerFrame / 1000, newLastIdealStyleValue, newLastIdealVelocityValue, styleValue.val, styleValue.stiffness, styleValue.damping, styleValue.precision);

                newLastIdealStyleValue = _stepper[0];
                newLastIdealVelocityValue = _stepper[1];
              }

              var _stepper2 = _stepper4['default'](msPerFrame / 1000, newLastIdealStyleValue, newLastIdealVelocityValue, styleValue.val, styleValue.stiffness, styleValue.damping, styleValue.precision);

              var nextIdealX = _stepper2[0];
              var nextIdealV = _stepper2[1];

              newCurrentStyle[key] = newLastIdealStyleValue + (nextIdealX - newLastIdealStyleValue) * currentFrameCompletion;
              newCurrentVelocity[key] = newLastIdealVelocityValue + (nextIdealV - newLastIdealVelocityValue) * currentFrameCompletion;
              newLastIdealStyle[key] = newLastIdealStyleValue;
              newLastIdealVelocity[key] = newLastIdealVelocityValue;
            }
          }

          newCurrentStyles[i] = newCurrentStyle;
          newCurrentVelocities[i] = newCurrentVelocity;
          newLastIdealStyles[i] = newLastIdealStyle;
          newLastIdealVelocities[i] = newLastIdealVelocity;
        }

        _this.animationID = null;
        // the amount we're looped over above
        _this.accumulatedTime -= framesToCatchUp * msPerFrame;

        _this.setState({
          currentStyles: newCurrentStyles,
          currentVelocities: newCurrentVelocities,
          lastIdealStyles: newLastIdealStyles,
          lastIdealVelocities: newLastIdealVelocities
        });

        _this.unreadPropStyles = null;

        _this.startAnimationIfNecessary();
      });
    };

    this.state = this.defaultState();
  }

  StaggeredMotion.prototype.defaultState = function defaultState() {
    var _props = this.props;
    var defaultStyles = _props.defaultStyles;
    var styles = _props.styles;

    var currentStyles = defaultStyles || styles().map(_stripStyle2['default']);
    var currentVelocities = currentStyles.map(function (currentStyle) {
      return _mapToZero2['default'](currentStyle);
    });
    return {
      currentStyles: currentStyles,
      currentVelocities: currentVelocities,
      lastIdealStyles: currentStyles,
      lastIdealVelocities: currentVelocities
    };
  };

  StaggeredMotion.prototype.componentDidMount = function componentDidMount() {
    this.prevTime = _performanceNow2['default']();
    this.startAnimationIfNecessary();
  };

  StaggeredMotion.prototype.componentWillReceiveProps = function componentWillReceiveProps(props) {
    if (this.unreadPropStyles != null) {
      // previous props haven't had the chance to be set yet; set them here
      this.clearUnreadPropStyle(this.unreadPropStyles);
    }

    this.unreadPropStyles = props.styles(this.state.lastIdealStyles);
    if (this.animationID == null) {
      this.prevTime = _performanceNow2['default']();
      this.startAnimationIfNecessary();
    }
  };

  StaggeredMotion.prototype.componentWillUnmount = function componentWillUnmount() {
    if (this.animationID != null) {
      _raf2['default'].cancel(this.animationID);
      this.animationID = null;
    }
  };

  StaggeredMotion.prototype.render = function render() {
    var renderedChildren = this.props.children(this.state.currentStyles);
    return renderedChildren && _react2['default'].Children.only(renderedChildren);
  };

  return StaggeredMotion;
})(_react2['default'].Component);

exports['default'] = StaggeredMotion;
module.exports = exports['default'];

// it's possible that currentStyle's value is stale: if props is immediately
// changed from 0 to 400 to spring(0) again, the async currentStyle is still
// at 0 (didn't have time to tick and interpolate even once). If we naively
// compare currentStyle with destVal it'll be 0 === 0 (no animation, stop).
// In reality currentStyle should be 400

// after checking for unreadPropStyles != null, we manually go set the
// non-interpolating values (those that are a number, without a spring
// config)
});

unwrapExports(StaggeredMotion_1);

var mergeDiff_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;
exports['default'] = mergeDiff;

function mergeDiff(prev, next, onRemove) {
  // bookkeeping for easier access of a key's index below. This is 2 allocations +
  // potentially triggering chrome hash map mode for objs (so it might be faster

  var prevKeyIndex = {};
  for (var i = 0; i < prev.length; i++) {
    prevKeyIndex[prev[i].key] = i;
  }
  var nextKeyIndex = {};
  for (var i = 0; i < next.length; i++) {
    nextKeyIndex[next[i].key] = i;
  }

  // first, an overly elaborate way of merging prev and next, eliminating
  // duplicates (in terms of keys). If there's dupe, keep the item in next).
  // This way of writing it saves allocations
  var ret = [];
  for (var i = 0; i < next.length; i++) {
    ret[i] = next[i];
  }
  for (var i = 0; i < prev.length; i++) {
    if (!Object.prototype.hasOwnProperty.call(nextKeyIndex, prev[i].key)) {
      // this is called my TM's `mergeAndSync`, which calls willLeave. We don't
      // merge in keys that the user desires to kill
      var fill = onRemove(i, prev[i]);
      if (fill != null) {
        ret.push(fill);
      }
    }
  }

  // now all the items all present. Core sorting logic to have the right order
  return ret.sort(function (a, b) {
    var nextOrderA = nextKeyIndex[a.key];
    var nextOrderB = nextKeyIndex[b.key];
    var prevOrderA = prevKeyIndex[a.key];
    var prevOrderB = prevKeyIndex[b.key];

    if (nextOrderA != null && nextOrderB != null) {
      // both keys in next
      return nextKeyIndex[a.key] - nextKeyIndex[b.key];
    } else if (prevOrderA != null && prevOrderB != null) {
      // both keys in prev
      return prevKeyIndex[a.key] - prevKeyIndex[b.key];
    } else if (nextOrderA != null) {
      // key a in next, key b in prev

      // how to determine the order between a and b? We find a "pivot" (term
      // abuse), a key present in both prev and next, that is sandwiched between
      // a and b. In the context of our above example, if we're comparing a and
      // d, b's (the only) pivot
      for (var i = 0; i < next.length; i++) {
        var pivot = next[i].key;
        if (!Object.prototype.hasOwnProperty.call(prevKeyIndex, pivot)) {
          continue;
        }

        if (nextOrderA < nextKeyIndex[pivot] && prevOrderB > prevKeyIndex[pivot]) {
          return -1;
        } else if (nextOrderA > nextKeyIndex[pivot] && prevOrderB < prevKeyIndex[pivot]) {
          return 1;
        }
      }
      // pluggable. default to: next bigger than prev
      return 1;
    }
    // prevOrderA, nextOrderB
    for (var i = 0; i < next.length; i++) {
      var pivot = next[i].key;
      if (!Object.prototype.hasOwnProperty.call(prevKeyIndex, pivot)) {
        continue;
      }
      if (nextOrderB < nextKeyIndex[pivot] && prevOrderA > prevKeyIndex[pivot]) {
        return 1;
      } else if (nextOrderB > nextKeyIndex[pivot] && prevOrderA < prevKeyIndex[pivot]) {
        return -1;
      }
    }
    // pluggable. default to: next bigger than prev
    return -1;
  });
}

module.exports = exports['default'];
// to loop through and find a key's index each time), but I no longer care
});

unwrapExports(mergeDiff_1);

var TransitionMotion_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }



var _mapToZero2 = _interopRequireDefault(mapToZero_1);



var _stripStyle2 = _interopRequireDefault(stripStyle_1);



var _stepper4 = _interopRequireDefault(stepper_1);



var _mergeDiff2 = _interopRequireDefault(mergeDiff_1);



var _performanceNow2 = _interopRequireDefault(performanceNow);



var _raf2 = _interopRequireDefault(raf_1);



var _shouldStopAnimation2 = _interopRequireDefault(shouldStopAnimation_1);



var _react2 = _interopRequireDefault(React__default);



var _propTypes2 = _interopRequireDefault(_propTypes);

var msPerFrame = 1000 / 60;

// the children function & (potential) styles function asks as param an
// Array<TransitionPlainStyle>, where each TransitionPlainStyle is of the format
// {key: string, data?: any, style: PlainStyle}. However, the way we keep
// internal states doesn't contain such a data structure (check the state and
// TransitionMotionState). So when children function and others ask for such
// data we need to generate them on the fly by combining mergedPropsStyles and
// currentStyles/lastIdealStyles
function rehydrateStyles(mergedPropsStyles, unreadPropStyles, plainStyles) {
  // Copy the value to a `const` so that Flow understands that the const won't
  // change and will be non-nullable in the callback below.
  var cUnreadPropStyles = unreadPropStyles;
  if (cUnreadPropStyles == null) {
    return mergedPropsStyles.map(function (mergedPropsStyle, i) {
      return {
        key: mergedPropsStyle.key,
        data: mergedPropsStyle.data,
        style: plainStyles[i]
      };
    });
  }
  return mergedPropsStyles.map(function (mergedPropsStyle, i) {
    for (var j = 0; j < cUnreadPropStyles.length; j++) {
      if (cUnreadPropStyles[j].key === mergedPropsStyle.key) {
        return {
          key: cUnreadPropStyles[j].key,
          data: cUnreadPropStyles[j].data,
          style: plainStyles[i]
        };
      }
    }
    return { key: mergedPropsStyle.key, data: mergedPropsStyle.data, style: plainStyles[i] };
  });
}

function shouldStopAnimationAll(currentStyles, destStyles, currentVelocities, mergedPropsStyles) {
  if (mergedPropsStyles.length !== destStyles.length) {
    return false;
  }

  for (var i = 0; i < mergedPropsStyles.length; i++) {
    if (mergedPropsStyles[i].key !== destStyles[i].key) {
      return false;
    }
  }

  // we have the invariant that mergedPropsStyles and
  // currentStyles/currentVelocities/last* are synced in terms of cells, see
  // mergeAndSync comment for more info
  for (var i = 0; i < mergedPropsStyles.length; i++) {
    if (!_shouldStopAnimation2['default'](currentStyles[i], destStyles[i].style, currentVelocities[i])) {
      return false;
    }
  }

  return true;
}

// core key merging logic

// things to do: say previously merged style is {a, b}, dest style (prop) is {b,
// c}, previous current (interpolating) style is {a, b}
// **invariant**: current[i] corresponds to merged[i] in terms of key

// steps:
// turn merged style into {a?, b, c}
//    add c, value of c is destStyles.c
//    maybe remove a, aka call willLeave(a), then merged is either {b, c} or {a, b, c}
// turn current (interpolating) style from {a, b} into {a?, b, c}
//    maybe remove a
//    certainly add c, value of c is willEnter(c)
// loop over merged and construct new current
// dest doesn't change, that's owner's
function mergeAndSync(willEnter, willLeave, didLeave, oldMergedPropsStyles, destStyles, oldCurrentStyles, oldCurrentVelocities, oldLastIdealStyles, oldLastIdealVelocities) {
  var newMergedPropsStyles = _mergeDiff2['default'](oldMergedPropsStyles, destStyles, function (oldIndex, oldMergedPropsStyle) {
    var leavingStyle = willLeave(oldMergedPropsStyle);
    if (leavingStyle == null) {
      didLeave({ key: oldMergedPropsStyle.key, data: oldMergedPropsStyle.data });
      return null;
    }
    if (_shouldStopAnimation2['default'](oldCurrentStyles[oldIndex], leavingStyle, oldCurrentVelocities[oldIndex])) {
      didLeave({ key: oldMergedPropsStyle.key, data: oldMergedPropsStyle.data });
      return null;
    }
    return { key: oldMergedPropsStyle.key, data: oldMergedPropsStyle.data, style: leavingStyle };
  });

  var newCurrentStyles = [];
  var newCurrentVelocities = [];
  var newLastIdealStyles = [];
  var newLastIdealVelocities = [];
  for (var i = 0; i < newMergedPropsStyles.length; i++) {
    var newMergedPropsStyleCell = newMergedPropsStyles[i];
    var foundOldIndex = null;
    for (var j = 0; j < oldMergedPropsStyles.length; j++) {
      if (oldMergedPropsStyles[j].key === newMergedPropsStyleCell.key) {
        foundOldIndex = j;
        break;
      }
    }
    // TODO: key search code
    if (foundOldIndex == null) {
      var plainStyle = willEnter(newMergedPropsStyleCell);
      newCurrentStyles[i] = plainStyle;
      newLastIdealStyles[i] = plainStyle;

      var velocity = _mapToZero2['default'](newMergedPropsStyleCell.style);
      newCurrentVelocities[i] = velocity;
      newLastIdealVelocities[i] = velocity;
    } else {
      newCurrentStyles[i] = oldCurrentStyles[foundOldIndex];
      newLastIdealStyles[i] = oldLastIdealStyles[foundOldIndex];
      newCurrentVelocities[i] = oldCurrentVelocities[foundOldIndex];
      newLastIdealVelocities[i] = oldLastIdealVelocities[foundOldIndex];
    }
  }

  return [newMergedPropsStyles, newCurrentStyles, newCurrentVelocities, newLastIdealStyles, newLastIdealVelocities];
}

var TransitionMotion = (function (_React$Component) {
  _inherits(TransitionMotion, _React$Component);

  _createClass(TransitionMotion, null, [{
    key: 'propTypes',
    value: {
      defaultStyles: _propTypes2['default'].arrayOf(_propTypes2['default'].shape({
        key: _propTypes2['default'].string.isRequired,
        data: _propTypes2['default'].any,
        style: _propTypes2['default'].objectOf(_propTypes2['default'].number).isRequired
      })),
      styles: _propTypes2['default'].oneOfType([_propTypes2['default'].func, _propTypes2['default'].arrayOf(_propTypes2['default'].shape({
        key: _propTypes2['default'].string.isRequired,
        data: _propTypes2['default'].any,
        style: _propTypes2['default'].objectOf(_propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].object])).isRequired
      }))]).isRequired,
      children: _propTypes2['default'].func.isRequired,
      willEnter: _propTypes2['default'].func,
      willLeave: _propTypes2['default'].func,
      didLeave: _propTypes2['default'].func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      willEnter: function willEnter(styleThatEntered) {
        return _stripStyle2['default'](styleThatEntered.style);
      },
      // recall: returning null makes the current unmounting TransitionStyle
      // disappear immediately
      willLeave: function willLeave() {
        return null;
      },
      didLeave: function didLeave() {}
    },
    enumerable: true
  }]);

  function TransitionMotion(props) {
    var _this = this;

    _classCallCheck(this, TransitionMotion);

    _React$Component.call(this, props);
    this.unmounting = false;
    this.animationID = null;
    this.prevTime = 0;
    this.accumulatedTime = 0;
    this.unreadPropStyles = null;

    this.clearUnreadPropStyle = function (unreadPropStyles) {
      var _mergeAndSync = mergeAndSync(_this.props.willEnter, _this.props.willLeave, _this.props.didLeave, _this.state.mergedPropsStyles, unreadPropStyles, _this.state.currentStyles, _this.state.currentVelocities, _this.state.lastIdealStyles, _this.state.lastIdealVelocities);

      var mergedPropsStyles = _mergeAndSync[0];
      var currentStyles = _mergeAndSync[1];
      var currentVelocities = _mergeAndSync[2];
      var lastIdealStyles = _mergeAndSync[3];
      var lastIdealVelocities = _mergeAndSync[4];

      for (var i = 0; i < unreadPropStyles.length; i++) {
        var unreadPropStyle = unreadPropStyles[i].style;
        var dirty = false;

        for (var key in unreadPropStyle) {
          if (!Object.prototype.hasOwnProperty.call(unreadPropStyle, key)) {
            continue;
          }

          var styleValue = unreadPropStyle[key];
          if (typeof styleValue === 'number') {
            if (!dirty) {
              dirty = true;
              currentStyles[i] = _extends({}, currentStyles[i]);
              currentVelocities[i] = _extends({}, currentVelocities[i]);
              lastIdealStyles[i] = _extends({}, lastIdealStyles[i]);
              lastIdealVelocities[i] = _extends({}, lastIdealVelocities[i]);
              mergedPropsStyles[i] = {
                key: mergedPropsStyles[i].key,
                data: mergedPropsStyles[i].data,
                style: _extends({}, mergedPropsStyles[i].style)
              };
            }
            currentStyles[i][key] = styleValue;
            currentVelocities[i][key] = 0;
            lastIdealStyles[i][key] = styleValue;
            lastIdealVelocities[i][key] = 0;
            mergedPropsStyles[i].style[key] = styleValue;
          }
        }
      }

      // unlike the other 2 components, we can't detect staleness and optionally
      // opt out of setState here. each style object's data might contain new
      // stuff we're not/cannot compare
      _this.setState({
        currentStyles: currentStyles,
        currentVelocities: currentVelocities,
        mergedPropsStyles: mergedPropsStyles,
        lastIdealStyles: lastIdealStyles,
        lastIdealVelocities: lastIdealVelocities
      });
    };

    this.startAnimationIfNecessary = function () {
      if (_this.unmounting) {
        return;
      }

      // TODO: when config is {a: 10} and dest is {a: 10} do we raf once and
      // call cb? No, otherwise accidental parent rerender causes cb trigger
      _this.animationID = _raf2['default'](function (timestamp) {
        // https://github.com/chenglou/react-motion/pull/420
        // > if execution passes the conditional if (this.unmounting), then
        // executes async defaultRaf and after that component unmounts and after
        // that the callback of defaultRaf is called, then setState will be called
        // on unmounted component.
        if (_this.unmounting) {
          return;
        }

        var propStyles = _this.props.styles;
        var destStyles = typeof propStyles === 'function' ? propStyles(rehydrateStyles(_this.state.mergedPropsStyles, _this.unreadPropStyles, _this.state.lastIdealStyles)) : propStyles;

        // check if we need to animate in the first place
        if (shouldStopAnimationAll(_this.state.currentStyles, destStyles, _this.state.currentVelocities, _this.state.mergedPropsStyles)) {
          // no need to cancel animationID here; shouldn't have any in flight
          _this.animationID = null;
          _this.accumulatedTime = 0;
          return;
        }

        var currentTime = timestamp || _performanceNow2['default']();
        var timeDelta = currentTime - _this.prevTime;
        _this.prevTime = currentTime;
        _this.accumulatedTime = _this.accumulatedTime + timeDelta;
        // more than 10 frames? prolly switched browser tab. Restart
        if (_this.accumulatedTime > msPerFrame * 10) {
          _this.accumulatedTime = 0;
        }

        if (_this.accumulatedTime === 0) {
          // no need to cancel animationID here; shouldn't have any in flight
          _this.animationID = null;
          _this.startAnimationIfNecessary();
          return;
        }

        var currentFrameCompletion = (_this.accumulatedTime - Math.floor(_this.accumulatedTime / msPerFrame) * msPerFrame) / msPerFrame;
        var framesToCatchUp = Math.floor(_this.accumulatedTime / msPerFrame);

        var _mergeAndSync2 = mergeAndSync(_this.props.willEnter, _this.props.willLeave, _this.props.didLeave, _this.state.mergedPropsStyles, destStyles, _this.state.currentStyles, _this.state.currentVelocities, _this.state.lastIdealStyles, _this.state.lastIdealVelocities);

        var newMergedPropsStyles = _mergeAndSync2[0];
        var newCurrentStyles = _mergeAndSync2[1];
        var newCurrentVelocities = _mergeAndSync2[2];
        var newLastIdealStyles = _mergeAndSync2[3];
        var newLastIdealVelocities = _mergeAndSync2[4];

        for (var i = 0; i < newMergedPropsStyles.length; i++) {
          var newMergedPropsStyle = newMergedPropsStyles[i].style;
          var newCurrentStyle = {};
          var newCurrentVelocity = {};
          var newLastIdealStyle = {};
          var newLastIdealVelocity = {};

          for (var key in newMergedPropsStyle) {
            if (!Object.prototype.hasOwnProperty.call(newMergedPropsStyle, key)) {
              continue;
            }

            var styleValue = newMergedPropsStyle[key];
            if (typeof styleValue === 'number') {
              newCurrentStyle[key] = styleValue;
              newCurrentVelocity[key] = 0;
              newLastIdealStyle[key] = styleValue;
              newLastIdealVelocity[key] = 0;
            } else {
              var newLastIdealStyleValue = newLastIdealStyles[i][key];
              var newLastIdealVelocityValue = newLastIdealVelocities[i][key];
              for (var j = 0; j < framesToCatchUp; j++) {
                var _stepper = _stepper4['default'](msPerFrame / 1000, newLastIdealStyleValue, newLastIdealVelocityValue, styleValue.val, styleValue.stiffness, styleValue.damping, styleValue.precision);

                newLastIdealStyleValue = _stepper[0];
                newLastIdealVelocityValue = _stepper[1];
              }

              var _stepper2 = _stepper4['default'](msPerFrame / 1000, newLastIdealStyleValue, newLastIdealVelocityValue, styleValue.val, styleValue.stiffness, styleValue.damping, styleValue.precision);

              var nextIdealX = _stepper2[0];
              var nextIdealV = _stepper2[1];

              newCurrentStyle[key] = newLastIdealStyleValue + (nextIdealX - newLastIdealStyleValue) * currentFrameCompletion;
              newCurrentVelocity[key] = newLastIdealVelocityValue + (nextIdealV - newLastIdealVelocityValue) * currentFrameCompletion;
              newLastIdealStyle[key] = newLastIdealStyleValue;
              newLastIdealVelocity[key] = newLastIdealVelocityValue;
            }
          }

          newLastIdealStyles[i] = newLastIdealStyle;
          newLastIdealVelocities[i] = newLastIdealVelocity;
          newCurrentStyles[i] = newCurrentStyle;
          newCurrentVelocities[i] = newCurrentVelocity;
        }

        _this.animationID = null;
        // the amount we're looped over above
        _this.accumulatedTime -= framesToCatchUp * msPerFrame;

        _this.setState({
          currentStyles: newCurrentStyles,
          currentVelocities: newCurrentVelocities,
          lastIdealStyles: newLastIdealStyles,
          lastIdealVelocities: newLastIdealVelocities,
          mergedPropsStyles: newMergedPropsStyles
        });

        _this.unreadPropStyles = null;

        _this.startAnimationIfNecessary();
      });
    };

    this.state = this.defaultState();
  }

  TransitionMotion.prototype.defaultState = function defaultState() {
    var _props = this.props;
    var defaultStyles = _props.defaultStyles;
    var styles = _props.styles;
    var willEnter = _props.willEnter;
    var willLeave = _props.willLeave;
    var didLeave = _props.didLeave;

    var destStyles = typeof styles === 'function' ? styles(defaultStyles) : styles;

    // this is special. for the first time around, we don't have a comparison
    // between last (no last) and current merged props. we'll compute last so:
    // say default is {a, b} and styles (dest style) is {b, c}, we'll
    // fabricate last as {a, b}
    var oldMergedPropsStyles = undefined;
    if (defaultStyles == null) {
      oldMergedPropsStyles = destStyles;
    } else {
      oldMergedPropsStyles = defaultStyles.map(function (defaultStyleCell) {
        // TODO: key search code
        for (var i = 0; i < destStyles.length; i++) {
          if (destStyles[i].key === defaultStyleCell.key) {
            return destStyles[i];
          }
        }
        return defaultStyleCell;
      });
    }
    var oldCurrentStyles = defaultStyles == null ? destStyles.map(function (s) {
      return _stripStyle2['default'](s.style);
    }) : defaultStyles.map(function (s) {
      return _stripStyle2['default'](s.style);
    });
    var oldCurrentVelocities = defaultStyles == null ? destStyles.map(function (s) {
      return _mapToZero2['default'](s.style);
    }) : defaultStyles.map(function (s) {
      return _mapToZero2['default'](s.style);
    });

    var _mergeAndSync3 = mergeAndSync(
    // Because this is an old-style createReactClass component, Flow doesn't
    // understand that the willEnter and willLeave props have default values
    // and will always be present.
    willEnter, willLeave, didLeave, oldMergedPropsStyles, destStyles, oldCurrentStyles, oldCurrentVelocities, oldCurrentStyles, // oldLastIdealStyles really
    oldCurrentVelocities);

    var mergedPropsStyles = _mergeAndSync3[0];
    var currentStyles = _mergeAndSync3[1];
    var currentVelocities = _mergeAndSync3[2];
    var lastIdealStyles = _mergeAndSync3[3];
    var lastIdealVelocities = _mergeAndSync3[4];
    // oldLastIdealVelocities really

    return {
      currentStyles: currentStyles,
      currentVelocities: currentVelocities,
      lastIdealStyles: lastIdealStyles,
      lastIdealVelocities: lastIdealVelocities,
      mergedPropsStyles: mergedPropsStyles
    };
  };

  // after checking for unreadPropStyles != null, we manually go set the
  // non-interpolating values (those that are a number, without a spring
  // config)

  TransitionMotion.prototype.componentDidMount = function componentDidMount() {
    this.prevTime = _performanceNow2['default']();
    this.startAnimationIfNecessary();
  };

  TransitionMotion.prototype.componentWillReceiveProps = function componentWillReceiveProps(props) {
    if (this.unreadPropStyles) {
      // previous props haven't had the chance to be set yet; set them here
      this.clearUnreadPropStyle(this.unreadPropStyles);
    }

    var styles = props.styles;
    if (typeof styles === 'function') {
      this.unreadPropStyles = styles(rehydrateStyles(this.state.mergedPropsStyles, this.unreadPropStyles, this.state.lastIdealStyles));
    } else {
      this.unreadPropStyles = styles;
    }

    if (this.animationID == null) {
      this.prevTime = _performanceNow2['default']();
      this.startAnimationIfNecessary();
    }
  };

  TransitionMotion.prototype.componentWillUnmount = function componentWillUnmount() {
    this.unmounting = true;
    if (this.animationID != null) {
      _raf2['default'].cancel(this.animationID);
      this.animationID = null;
    }
  };

  TransitionMotion.prototype.render = function render() {
    var hydratedStyles = rehydrateStyles(this.state.mergedPropsStyles, this.unreadPropStyles, this.state.currentStyles);
    var renderedChildren = this.props.children(hydratedStyles);
    return renderedChildren && _react2['default'].Children.only(renderedChildren);
  };

  return TransitionMotion;
})(_react2['default'].Component);

exports['default'] = TransitionMotion;
module.exports = exports['default'];

// list of styles, each containing interpolating values. Part of what's passed
// to children function. Notice that this is
// Array<ActualInterpolatingStyleObject>, without the wrapper that is {key: ...,
// data: ... style: ActualInterpolatingStyleObject}. Only mergedPropsStyles
// contains the key & data info (so that we only have a single source of truth
// for these, and to save space). Check the comment for `rehydrateStyles` to
// see how we regenerate the entirety of what's passed to children function

// the array that keeps track of currently rendered stuff! Including stuff
// that you've unmounted but that's still animating. This is where it lives

// it's possible that currentStyle's value is stale: if props is immediately
// changed from 0 to 400 to spring(0) again, the async currentStyle is still
// at 0 (didn't have time to tick and interpolate even once). If we naively
// compare currentStyle with destVal it'll be 0 === 0 (no animation, stop).
// In reality currentStyle should be 400
});

unwrapExports(TransitionMotion_1);

var presets = createCommonjsModule(function (module, exports) {

exports.__esModule = true;
exports["default"] = {
  noWobble: { stiffness: 170, damping: 26 }, // the default, if nothing provided
  gentle: { stiffness: 120, damping: 14 },
  wobbly: { stiffness: 180, damping: 12 },
  stiff: { stiffness: 210, damping: 20 }
};
module.exports = exports["default"];
});

unwrapExports(presets);

var spring_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = spring;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }



var _presets2 = _interopRequireDefault(presets);

var defaultConfig = _extends({}, _presets2['default'].noWobble, {
  precision: 0.01
});

function spring(val, config) {
  return _extends({}, defaultConfig, config, { val: val });
}

module.exports = exports['default'];
});

unwrapExports(spring_1);

var reorderKeys_1 = createCommonjsModule(function (module, exports) {

exports.__esModule = true;
exports['default'] = reorderKeys;

var hasWarned = false;

function reorderKeys() {
  if (process.env.NODE_ENV === 'development') {
    if (!hasWarned) {
      hasWarned = true;
      console.error('`reorderKeys` has been removed, since it is no longer needed for TransitionMotion\'s new styles array API.');
    }
  }
}

module.exports = exports['default'];
});

unwrapExports(reorderKeys_1);

var reactMotion = createCommonjsModule(function (module, exports) {

exports.__esModule = true;

function _interopRequire(obj) { return obj && obj.__esModule ? obj['default'] : obj; }



exports.Motion = _interopRequire(Motion_1);



exports.StaggeredMotion = _interopRequire(StaggeredMotion_1);



exports.TransitionMotion = _interopRequire(TransitionMotion_1);



exports.spring = _interopRequire(spring_1);



exports.presets = _interopRequire(presets);



exports.stripStyle = _interopRequire(stripStyle_1);

// deprecated, dummy warning function



exports.reorderKeys = _interopRequire(reorderKeys_1);
});

unwrapExports(reactMotion);
var reactMotion_1 = reactMotion.Motion;
var reactMotion_2 = reactMotion.StaggeredMotion;
var reactMotion_3 = reactMotion.TransitionMotion;
var reactMotion_4 = reactMotion.spring;
var reactMotion_5 = reactMotion.presets;
var reactMotion_6 = reactMotion.stripStyle;
var reactMotion_7 = reactMotion.reorderKeys;

__$styleInject("._carousel-wrapper_4y5gg_1 {\n  position: relative;\n  width: 100%;\n  height: 100%;\n  perspective: 1000px;\n  /* overflow: hidden; */\n}\n\n._carousel-wrapper_4y5gg_1 ._carousel_4y5gg_1 {\n  width: 100%;\n  height: 100%;\n  position: absolute;\n  transform-style: preserve-3d;\n}\n\n._carousel-wrapper_4y5gg_1 ._carousel_4y5gg_1 ._carousel-cell_4y5gg_16 {\n  backface-visibility: hidden;\n  opacity: 0;\n  position: absolute;\n}\n", {});
var styles = {"carouselWrapper":"_carousel-wrapper_4y5gg_1","carousel":"_carousel_4y5gg_1","carouselCell":"_carousel-cell_4y5gg_16"};

var Carousel = /** @class */ (function (_super) {
    __extends(Carousel, _super);
    function Carousel(props) {
        var _this = _super.call(this, props) || this;
        _this.prev = function () {
            var is2dEffect = _this.state.is2dEffect;
            if (is2dEffect) {
                _this.changeCell({ target: 'prev' });
            }
            else {
                _this.changeCarousel({ target: 'prev' });
            }
        };
        _this.next = function () {
            var is2dEffect = _this.state.is2dEffect;
            if (is2dEffect) {
                _this.changeCell({ target: 'next' });
            }
            else {
                _this.changeCarousel({ target: 'next' });
            }
        };
        _this.move = function (params) {
            var index = params.index, index3d = params.index3d;
            var _a = _this.state, cells = _a.cells, width = _a.width, height = _a.height, isHorizontal = _a.isHorizontal, is2dEffect = _a.is2dEffect, radius = _a.radius, theta = _a.theta, carousel = _a.carousel;
            var newCells = cells.concat();
            var angle = theta * index3d * (isHorizontal ? -1 : 1);
            _this.setState({
                index: index,
                index3d: index3d,
                carousel: __assign({}, carousel, { rotate: __assign({}, carousel.rotate, { deg: angle }) }),
                cells: newCells.map(function (_, i) {
                    var idx = i === index ? 0 : i - index;
                    var x = isHorizontal ? idx * width : 0;
                    var y = isHorizontal ? 0 : idx * height;
                    var zIndex = i === index ? 100 : 1;
                    return {
                        translate: {
                            x: is2dEffect ? x : 0,
                            y: is2dEffect ? y : 0,
                            z: is2dEffect ? 0 : radius
                        },
                        rotate: {
                            x: is2dEffect ? 0 : isHorizontal ? 0 : 1,
                            y: is2dEffect ? 0 : isHorizontal ? 1 : 0,
                            z: 0,
                            deg: theta * i
                        },
                        opacity: 1,
                        zIndex: zIndex
                    };
                })
            });
        };
        _this.getMoveIndex = function (params) {
            var target = params.target;
            var _a = _this.state, index = _a.index, count = _a.count;
            var isPrev = target === 'prev';
            return isPrev
                ? index
                    ? index - 1
                    : count - 1
                : index === count - 1
                    ? 0
                    : index + 1;
        };
        _this.getIndex = function () {
            return _this.state.index;
        };
        _this.dragCell = function () {
            var _a = _this.state, cells = _a.cells, isHorizontal = _a.isHorizontal, width = _a.width, height = _a.height, count = _a.count, mouseDelta = _a.mouseDelta;
            var dx = mouseDelta[0], dy = mouseDelta[1];
            var newCells = cells.concat();
            newCells = newCells.map(function (cell) {
                var x = isHorizontal ? cell.translate.x + dx : 0;
                var y = isHorizontal ? 0 : cell.translate.y + dy;
                if (Math.abs(x) >= width * (count - 1)) {
                    x = (width - (x % width) * (x > 0 ? 1 : -1)) * (x > 0 ? -1 : 1);
                }
                if (Math.abs(y) >= height * (count - 1)) {
                    y = (height - (x % height) * (y > 0 ? 1 : -1)) * (y > 0 ? -1 : 1);
                }
                return __assign({}, cell, { translate: {
                        x: x,
                        y: y,
                        z: 0
                    } });
            });
            _this.setState(function () {
                return {
                    cells: newCells
                };
            });
        };
        _this.changeCell = function (params) {
            var target = params.target;
            var _a = _this.state, index = _a.index, cells = _a.cells, isHorizontal = _a.isHorizontal, width = _a.width, height = _a.height, count = _a.count;
            var isPrev = target === 'prev';
            var moveIndex = _this.getMoveIndex({ target: target });
            var newCells = cells.concat();
            newCells = newCells.map(function (cell, i) {
                var x = isHorizontal ? cell.translate.x + (isPrev ? width : -width) : 0;
                var y = isHorizontal
                    ? 0
                    : cell.translate.y + (isPrev ? height : -height);
                var opacity = i === index || i === moveIndex ? 1 : 0;
                var zIndex = i === index ? 100 : 1;
                if (Math.abs(x) === width * (count - 1)) {
                    x = isPrev ? -width : width;
                }
                if (Math.abs(y) === height * (count - 1)) {
                    y = isPrev ? -height : height;
                }
                return __assign({}, cell, { translate: {
                        x: x,
                        y: y,
                        z: 0
                    }, opacity: opacity,
                    zIndex: zIndex });
            });
            _this.setState(function () {
                return {
                    index: moveIndex,
                    cells: newCells
                };
            });
        };
        _this.dragCarousel = function () {
            var _a = _this.state, carousel = _a.carousel, isHorizontal = _a.isHorizontal, mouseDelta = _a.mouseDelta;
            var dx = mouseDelta[0], dy = mouseDelta[1];
            _this.setState({
                carousel: __assign({}, carousel, { rotate: __assign({}, carousel.rotate, { deg: carousel.rotate.deg + (isHorizontal ? dx : dy) }) })
            });
        };
        _this.changeCarousel = function (params) {
            var target = params.target;
            var _a = _this.state, index3d = _a.index3d, theta = _a.theta, isHorizontal = _a.isHorizontal;
            var isPrev = target === 'prev';
            var moveIndex = isPrev ? index3d - 1 : index3d + 1;
            var angle = theta * moveIndex * (isHorizontal ? -1 : 1);
            _this.setState(function (prevState) {
                return {
                    index: _this.getMoveIndex({ target: target }),
                    index3d: moveIndex,
                    carousel: __assign({}, prevState.carousel, { rotate: __assign({}, prevState.carousel.rotate, { deg: angle }) })
                };
            });
        };
        _this.handleMouseDown = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            _this.setState({
                isPressed: true,
                isMoved: false,
                mouseXY: [pageX, pageY]
            });
            e.preventDefault();
        };
        _this.handleClick = function (e) {
            var _a = _this.props.onClick, onClick = _a === void 0 ? function () { } : _a;
            var _b = _this.state, distance = _b.distance, count = _b.count;
            if (Math.abs(distance) < 10 || count < 2) {
                onClick();
            }
            else {
                e.preventDefault();
                e.stopPropagation();
            }
        };
        _this.handleMouseMove = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            var _a = _this.state, isPressed = _a.isPressed, _b = _a.mouseXY, mx = _b[0], my = _b[1], is2dEffect = _a.is2dEffect;
            if (isPressed) {
                _this.setState({
                    mouseXY: [pageX, pageY],
                    mouseDelta: [pageX - mx, pageY - my],
                    isMoved: true
                });
                if (is2dEffect) {
                    _this.dragCell();
                }
                else {
                    _this.dragCarousel();
                }
            }
        };
        _this.handleMouseUp = function () {
            var _a = _this.state, index = _a.index, index3d = _a.index3d, cells = _a.cells, count = _a.count, isPressed = _a.isPressed, width = _a.width, height = _a.height, is2dEffect = _a.is2dEffect, isHorizontal = _a.isHorizontal, carousel = _a.carousel, theta = _a.theta;
            if (isPressed) {
                _this.setState({
                    isPressed: false,
                    mouseXY: [0, 0],
                    mouseDelta: [0, 0]
                });
                if (is2dEffect) {
                    cells.map(function (cell, i) {
                        if (index === i) {
                            var distance = isHorizontal
                                ? cell.translate.x % width
                                : cell.translate.y % height;
                            _this.setState({
                                distance: distance
                            });
                            if ((isHorizontal ? width : height) / 2 < Math.abs(distance)) {
                                var moveIndex = distance > 0
                                    ? index - 1 < 0
                                        ? count - 1
                                        : index - 1
                                    : index + 1 === count
                                        ? 0
                                        : index + 1;
                                _this.move({ index: moveIndex, index3d: index3d });
                            }
                            else {
                                _this.move({ index: index, index3d: index3d });
                            }
                        }
                        return cell;
                    });
                }
                else {
                    var deg = carousel.rotate.deg;
                    var distance = index3d === 0
                        ? deg % theta
                        : Math.abs(deg) > Math.abs(theta * index3d)
                            ? deg % theta
                            : (theta * index3d) % deg;
                    _this.setState({
                        distance: distance
                    });
                    if (theta / count < Math.abs(distance)) {
                        var target = distance > 0 ? 'prev' : 'next';
                        _this.changeCarousel({ target: target });
                    }
                    else {
                        _this.move({ index: index, index3d: index3d });
                    }
                }
            }
        };
        _this.state = {
            index: 0,
            index3d: 0,
            width: 0,
            height: 0,
            mouseXY: [0, 0],
            mouseDelta: [0, 0],
            distance: 0,
            isMoved: false,
            isPressed: false,
            isHorizontal: false,
            is2dEffect: false,
            count: 0,
            theta: 0,
            radius: 0,
            carousel: {
                translate: {
                    x: 0,
                    y: 0,
                    z: 0
                },
                rotate: {
                    x: 0,
                    y: 0,
                    z: 0,
                    deg: 0
                }
            },
            cells: [],
            children: []
        };
        return _this;
    }
    Carousel.getDerivedStateFromProps = function (nextProps) {
        var children = nextProps.children;
        var newChildren = Array.isArray(children) ? children.slice() : [children];
        var count = newChildren.length;
        return {
            count: count,
            children: newChildren
        };
    };
    Carousel.prototype.componentDidMount = function () {
        var _a = this.props, _b = _a.index, index = _b === void 0 ? 0 : _b, width = _a.width, height = _a.height, _c = _a.direction, direction = _c === void 0 ? 'horizontal' : _c, _d = _a.effect, effect = _d === void 0 ? '2d' : _d, children = _a.children;
        var isHorizontal = direction === 'horizontal';
        var is2dEffect = effect === '2d';
        var newChildren = Array.isArray(children) ? children.slice() : [children];
        var count = newChildren.length;
        var theta = 360 / count;
        var cellSize = isHorizontal ? width : height;
        var radius = Math.round(cellSize / 2 / Math.tan(Math.PI / count));
        this.setState({
            index: index,
            index3d: index,
            width: width,
            height: height,
            isHorizontal: isHorizontal,
            is2dEffect: is2dEffect,
            count: count,
            theta: theta,
            radius: radius,
            carousel: {
                translate: {
                    x: 0,
                    y: 0,
                    z: is2dEffect ? 0 : -radius
                },
                rotate: {
                    x: is2dEffect ? 0 : isHorizontal ? 0 : 1,
                    y: is2dEffect ? 0 : isHorizontal ? 1 : 0,
                    z: 0,
                    deg: theta * index * -1
                }
            },
            cells: newChildren.map(function (_, i) {
                var idx = i === index ? 0 : i - index;
                var x, y;
                x = isHorizontal ? idx * width : 0;
                y = isHorizontal ? 0 : idx * height;
                if (Math.abs(x) === width * (count - 1)) {
                    x = -width;
                }
                if (Math.abs(y) === height * (count - 1)) {
                    y = -height;
                }
                return {
                    translate: {
                        x: is2dEffect ? x : 0,
                        y: is2dEffect ? y : 0,
                        z: is2dEffect ? 0 : radius
                    },
                    rotate: {
                        x: is2dEffect ? 0 : isHorizontal ? 0 : 1,
                        y: is2dEffect ? 0 : isHorizontal ? 1 : 0,
                        z: 0,
                        deg: theta * i
                    },
                    opacity: 1,
                    zIndex: 1
                };
            }),
            children: newChildren
        });
    };
    Carousel.prototype.render = function () {
        var _this = this;
        var _a = this.state, carousel = _a.carousel, count = _a.count, children = _a.children, is2dEffect = _a.is2dEffect, width = _a.width, height = _a.height, cells = _a.cells;
        if (count < 2) {
            return (createElement("div", { style: {
                    width: width,
                    height: height
                }, onClick: function (e) {
                    _this.handleClick(e);
                } }, children));
        }
        return (createElement("div", { className: styles.carouselWrapper },
            createElement(reactMotion_1, { style: {
                    rotateDeg: reactMotion_4(carousel.rotate.deg)
                } }, function (_a) {
                var rotateDeg = _a.rotateDeg;
                return (createElement("div", { className: styles.carousel, style: {
                        transform: "translate3d(" + carousel.translate.x + "px, " + carousel.translate.y + "px, " + carousel.translate.z + "px) " + (is2dEffect
                            ? ''
                            : "rotate3d(" + carousel.rotate.x + ", " + carousel.rotate.y + ", " + carousel.rotate.z + ", " + rotateDeg + "deg)")
                    } }, children.map(function (child, key) {
                    var cell = cells[key];
                    if (!cells.length) {
                        return null;
                    }
                    return (createElement(reactMotion_1, { key: key, style: {
                            translateX: reactMotion_4(cell.translate.x),
                            translateY: reactMotion_4(cell.translate.y)
                        } }, function (_a) {
                        var translateX = _a.translateX, translateY = _a.translateY;
                        return (createElement("div", { className: styles.carouselCell, style: {
                                transform: "" + (is2dEffect
                                    ? ''
                                    : "rotate3d(" + cell.rotate.x + ", " + cell.rotate.y + ", " + cell.rotate.z + ", " + cell.rotate.deg + "deg)") + ("translate3d(" + translateX + "px," + translateY + "px, " + cell.translate.z + "px)"),
                                opacity: cell.opacity,
                                width: width,
                                height: height,
                                zIndex: cell.zIndex
                            }, onMouseDown: function (e) {
                                _this.handleMouseDown(e);
                            }, onClick: function (e) {
                                _this.handleClick(e);
                            }, onMouseMove: function (e) {
                                _this.handleMouseMove(e);
                            }, onMouseLeave: function () {
                                _this.handleMouseUp();
                            }, onMouseUp: function () {
                                _this.handleMouseUp();
                            } }, child));
                    }));
                })));
            })));
    };
    return Carousel;
}(Component));

__$styleInject("._cube-wrapper_bssuh_1 {\n  position: relative;\n  width: 100%;\n  height: 100%;\n  perspective: 1000px;\n  /* overflow: hidden; */\n}\n\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 {\n  width: 100%;\n  height: 100%;\n  position: absolute;\n  transform-style: preserve-3d;\n}\n\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16 {\n  position: absolute;\n}\n\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16 img {\n  width: 100%;\n  height: 100%;\n}\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16 ._empty_bssuh_24 {\n  width: 100%;\n  height: 100%;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16._front_bssuh_32 ._empty_bssuh_24 {\n  background: hsla(0, 100%, 50%, 0.7);\n}\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16._right_bssuh_35 ._empty_bssuh_24 {\n  background: hsla(60, 100%, 50%, 0.7);\n}\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16._back_bssuh_38 ._empty_bssuh_24 {\n  background: hsla(120, 100%, 50%, 0.7);\n}\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16._left_bssuh_41 ._empty_bssuh_24 {\n  background: hsla(180, 100%, 50%, 0.7);\n}\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16._top_bssuh_44 ._empty_bssuh_24 {\n  background: hsla(240, 100%, 50%, 0.7);\n}\n._cube-wrapper_bssuh_1 ._cube_bssuh_1 ._cube-face_bssuh_16._bottom_bssuh_47 ._empty_bssuh_24 {\n  background: hsla(300, 100%, 50%, 0.7);\n}\n", {});
var styles$1 = {"cubeWrapper":"_cube-wrapper_bssuh_1","cube":"_cube_bssuh_1","cubeFace":"_cube-face_bssuh_16","empty":"_empty_bssuh_24","front":"_front_bssuh_32","right":"_right_bssuh_35","back":"_back_bssuh_38","left":"_left_bssuh_41","top":"_top_bssuh_44","bottom":"_bottom_bssuh_47"};

var emptyFace = createElement("div", { className: styles$1.empty }, "empty");
var Cube = /** @class */ (function (_super) {
    __extends(Cube, _super);
    function Cube(props) {
        var _this = _super.call(this, props) || this;
        _this.dragCube = function () {
            var _a = _this.state, cube = _a.cube, mouseDelta = _a.mouseDelta;
            var dx = mouseDelta[0], dy = mouseDelta[1];
            var rotateX = cube.rotateX - dy;
            var absX = Math.abs(rotateX % 360);
            var rotateY = absX > 90 && absX < 270 ? cube.rotateY - dx : cube.rotateY + dx;
            _this.setState({
                cube: __assign({}, cube, { rotateX: rotateX,
                    rotateY: rotateY })
            });
        };
        _this.handleMouseDown = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            _this.setState({
                isPressed: true,
                isMoved: false,
                mouseXY: [pageX, pageY]
            });
            e.preventDefault();
        };
        _this.handleMouseMove = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            var _a = _this.state, isPressed = _a.isPressed, _b = _a.mouseXY, mx = _b[0], my = _b[1];
            if (isPressed) {
                _this.setState({
                    mouseXY: [pageX, pageY],
                    mouseDelta: [pageX - mx, pageY - my],
                    isMoved: true
                });
                _this.dragCube();
            }
        };
        _this.handleMouseUp = function () {
            var isPressed = _this.state.isPressed;
            if (isPressed) {
                _this.setState({
                    isPressed: false,
                    mouseXY: [0, 0],
                    mouseDelta: [0, 0]
                });
            }
        };
        var _a = _this.props, _b = _a.index, index = _b === void 0 ? 'front' : _b, _c = _a.size, size = _c === void 0 ? 200 : _c;
        var faceSize = size / 2;
        _this.state = {
            index: index,
            isMoved: false,
            isPressed: false,
            mouseXY: [0, 0],
            mouseDelta: [0, 0],
            distance: 0,
            cube: {
                width: size,
                height: size,
                translate: {
                    x: 0,
                    y: 0,
                    z: -faceSize
                },
                rotateX: 0,
                rotateY: 0,
                rotateZ: 0
            },
            faces: {
                front: {
                    translate: {
                        x: 0,
                        y: 0,
                        z: faceSize
                    },
                    rotate: {
                        x: 0,
                        y: 1,
                        z: 0,
                        deg: 0
                    }
                },
                right: {
                    translate: {
                        x: faceSize,
                        y: 0,
                        z: 0
                    },
                    rotate: {
                        x: 0,
                        y: 1,
                        z: 0,
                        deg: 90
                    }
                },
                back: {
                    translate: {
                        x: 0,
                        y: 0,
                        z: -faceSize
                    },
                    rotate: {
                        x: 0,
                        y: 1,
                        z: 0,
                        deg: 180
                    }
                },
                left: {
                    translate: {
                        x: -faceSize,
                        y: 0,
                        z: 0
                    },
                    rotate: {
                        x: 0,
                        y: 1,
                        z: 0,
                        deg: -90
                    }
                },
                top: {
                    translate: {
                        x: 0,
                        y: -faceSize,
                        z: 0
                    },
                    rotate: {
                        x: 1,
                        y: 0,
                        z: 0,
                        deg: 90
                    }
                },
                bottom: {
                    translate: {
                        x: 0,
                        y: faceSize,
                        z: 0
                    },
                    rotate: {
                        x: 1,
                        y: 0,
                        z: 0,
                        deg: -90
                    }
                }
            },
            children: []
        };
        return _this;
    }
    Cube.prototype.componentDidMount = function () {
        var children = this.props.children;
        var _a = this.state, index = _a.index, cube = _a.cube, faces = _a.faces;
        var newChildren = children
            ? Array.isArray(children)
                ? children.slice().slice(0, 6)
                : [children]
            : [];
        while (newChildren.length < 6) {
            newChildren.push(emptyFace);
        }
        this.setState({
            cube: __assign({}, cube, { rotateX: faces[index].rotate.x ? -faces[index].rotate.deg : 0, rotateY: faces[index].rotate.y ? -faces[index].rotate.deg : 0, rotateZ: 0 }),
            children: newChildren
        });
    };
    Cube.prototype.render = function () {
        var _this = this;
        var _a = this.state, cube = _a.cube, faces = _a.faces, children = _a.children;
        return (createElement("div", { className: styles$1.cubeWrapper },
            createElement(reactMotion_1, { style: {
                    rotateX: reactMotion_4(cube.rotateX),
                    rotateY: reactMotion_4(cube.rotateY),
                    rotateZ: reactMotion_4(cube.rotateZ)
                } }, function (_a) {
                var rotateX = _a.rotateX, rotateY = _a.rotateY, rotateZ = _a.rotateZ;
                return (createElement("div", { className: styles$1.cube, style: {
                        transform: "translate3d(" + cube.translate.x + "px, " + cube.translate.y + "px, " + cube.translate.z + "px) rotateX(" + rotateX + "deg) rotateY(" + rotateY + "deg) rotateZ(" + rotateZ + "deg)"
                    } }, Object.keys(faces).map(function (face, key) {
                    var _a = faces[face], translate = _a.translate, rotate = _a.rotate;
                    return (createElement("div", { className: styles$1.cubeFace + " " + styles$1[face], key: key, style: {
                            transform: "translate3d(" + translate.x + "px, " + translate.y + "px, " + translate.z + "px) rotate3d(" + rotate.x + ", " + rotate.y + ", " + rotate.z + ", " + rotate.deg + "deg)",
                            width: cube.width,
                            height: cube.height
                        }, onMouseDown: function (e) {
                            _this.handleMouseDown(e);
                        }, onMouseMove: function (e) {
                            _this.handleMouseMove(e);
                        }, onMouseLeave: function () {
                            _this.handleMouseUp();
                        }, onMouseUp: function () {
                            _this.handleMouseUp();
                        } }, children[key]));
                })));
            })));
    };
    return Cube;
}(Component));

function reinsert(params) {
    var arr = params.arr, from = params.from, to = params.to;
    var newArr = arr.slice(0);
    var val = newArr[from];
    newArr.splice(from, 1);
    newArr.splice(to, 0, val);
    return newArr;
}
function clamp(params) {
    var n = params.n, min = params.min, max = params.max;
    return Math.max(Math.min(n, max), min);
}
var DraggableList = /** @class */ (function (_super) {
    __extends(DraggableList, _super);
    function DraggableList(props) {
        var _this = _super.call(this, props) || this;
        _this.handleMouseDown = function (params) {
            var key = params.key, pressLocation = params.pressLocation, e = params.e;
            var pressX = pressLocation[0], pressY = pressLocation[1];
            var pageX = e.pageX, pageY = e.pageY;
            _this.setState({
                lastPress: key,
                isPressed: true,
                isMoved: false,
                mouseDelta: [pageX - pressX, pageY - pressY],
                mouseXY: [pressX, pressY]
            });
            e.preventDefault();
        };
        _this.handleClick = function (e) {
            var isMoved = _this.state.isMoved;
            if (isMoved) {
                e.preventDefault();
                e.stopPropagation();
            }
        };
        _this.handleMouseMove = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            var _a = _this.state, width = _a.width, height = _a.height, count = _a.count, orders = _a.orders, rowSize = _a.rowSize, lastPress = _a.lastPress, isPressed = _a.isPressed, _b = _a.mouseDelta, dx = _b[0], dy = _b[1];
            var _c = document.body, scrollWidth = _c.scrollWidth, scrollHeight = _c.scrollHeight;
            if (pageX < 0 || pageY < 0) {
                return;
            }
            if (pageX > scrollWidth || pageY > scrollHeight) {
                return;
            }
            if (isPressed) {
                var mouseXY = [pageX - dx, pageY - dy];
                var col = clamp({
                    n: Math.floor(mouseXY[0] / width),
                    min: 0,
                    max: rowSize - 1
                });
                var row = clamp({
                    n: Math.floor(mouseXY[1] / height),
                    min: 0,
                    max: Math.floor(count / rowSize)
                });
                var index = row * rowSize + col;
                var newOrders = reinsert({
                    arr: orders,
                    from: orders.indexOf(lastPress),
                    to: index
                });
                _this.setState({
                    mouseXY: mouseXY,
                    isMoved: Math.abs(mouseXY[0]) > 10 || Math.abs(mouseXY[1]) > 10,
                    orders: newOrders
                });
            }
        };
        _this.handleMouseUp = function () {
            _this.setState({
                isPressed: false,
                mouseDelta: [0, 0]
            });
        };
        _this.getLayout = function () {
            var _a = _this.state, count = _a.count, width = _a.width, height = _a.height, rowSize = _a.rowSize;
            return Array.from({ length: count }, function (_, n) {
                var row = Math.floor(n / rowSize);
                var col = n % rowSize;
                return [width * col, height * row];
            });
        };
        var _a = _this.props, _b = _a.rowSize, rowSize = _b === void 0 ? 3 : _b, width = _a.width, height = _a.height, children = _a.children;
        var newChildren = Array.isArray(children) ? children.slice() : [children];
        var count = newChildren.length;
        _this.state = {
            rowSize: rowSize,
            width: width,
            height: height,
            count: count,
            mouseXY: [0, 0],
            mouseDelta: [0, 0],
            lastPress: 0,
            isMoved: false,
            isPressed: false,
            orders: Array.from({ length: count }, function (_, i) {
                return i;
            }),
            children: newChildren
        };
        return _this;
    }
    DraggableList.prototype.componentDidMount = function () {
        window.addEventListener('mousemove', this.handleMouseMove);
        window.addEventListener('mouseup', this.handleMouseUp);
    };
    DraggableList.prototype.componentWillUnmount = function () {
        window.removeEventListener('mousemove', this.handleMouseMove);
        window.removeEventListener('mouseup', this.handleMouseUp);
    };
    DraggableList.prototype.render = function () {
        var _this = this;
        var _a = this.state, width = _a.width, height = _a.height, count = _a.count, rowSize = _a.rowSize, orders = _a.orders, lastPress = _a.lastPress, isPressed = _a.isPressed, mouseXY = _a.mouseXY, children = _a.children;
        return (createElement("div", { style: {
                height: height * Math.ceil(count / rowSize)
            } }, orders.map(function (_, key) {
            var _a;
            var style;
            var x;
            var y;
            var visualPosition = orders.indexOf(key);
            if (key === lastPress && isPressed) {
                x = mouseXY[0], y = mouseXY[1];
                style = {
                    translateX: x,
                    translateY: y,
                    scale: reactMotion_4(1.2)
                };
            }
            else {
                _a = _this.getLayout()[visualPosition], x = _a[0], y = _a[1];
                style = {
                    translateX: reactMotion_4(x),
                    translateY: reactMotion_4(y),
                    scale: reactMotion_4(1)
                };
            }
            return (createElement(reactMotion_1, { key: key, style: style }, function (_a) {
                var translateX = _a.translateX, translateY = _a.translateY, scale = _a.scale;
                return (createElement("div", { onMouseDown: function (e) {
                        _this.handleMouseDown({ key: key, pressLocation: [x, y], e: e });
                    }, onClickCapture: function (e) {
                        _this.handleClick(e);
                    }, 
                    // onMouseMove={e => {
                    //   this.handleMouseMove(e);
                    // }}
                    // onMouseUp={() => {
                    //   this.handleMouseUp();
                    // }}
                    style: {
                        position: 'absolute',
                        width: width,
                        height: height,
                        transform: "translate3d(" + translateX + "px, " + translateY + "px, 0) scale(" + scale + ")",
                        zIndex: key === lastPress ? 99 : visualPosition
                    } }, children[key]));
            }));
        })));
    };
    return DraggableList;
}(Component));

var StaggeredList = /** @class */ (function (_super) {
    __extends(StaggeredList, _super);
    function StaggeredList(props) {
        var _this = _super.call(this, props) || this;
        _this.getStyles = function (prevStyles) {
            var style = _this.state.style;
            return prevStyles.map(function (_, i) {
                return {
                    transformX: reactMotion_4(i === 0 ? style.transformX : prevStyles[i - 1].transformX),
                    transformY: reactMotion_4(i === 0 ? style.transformY : prevStyles[i - 1].transformY)
                };
            });
        };
        _this.dragItem = function () {
            var _a = _this.state, style = _a.style, mouseDelta = _a.mouseDelta;
            var dx = mouseDelta[0], dy = mouseDelta[1];
            _this.setState({
                style: {
                    transformX: style.transformX + dx,
                    transformY: style.transformY + dy
                }
            });
        };
        _this.handleMouseDown = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            _this.setState({
                isPressed: true,
                isMoved: false,
                mouseStart: [pageX, pageY],
                mouseXY: [pageX, pageY]
            });
            e.preventDefault();
        };
        _this.handleClick = function (e) {
            var _a = _this.state, mouseStart = _a.mouseStart, mouseXY = _a.mouseXY;
            var sx = mouseStart[0], sy = mouseStart[1];
            var mx = mouseXY[0], my = mouseXY[1];
            var distanceX = Math.abs(sx - mx);
            var distanceY = Math.abs(sy - my);
            if (distanceX || distanceY) {
                e.preventDefault();
                e.stopPropagation();
            }
        };
        _this.handleMouseMove = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            var _a = _this.state, isPressed = _a.isPressed, _b = _a.mouseXY, mx = _b[0], my = _b[1];
            if (isPressed) {
                _this.setState({
                    mouseXY: [pageX, pageY],
                    mouseDelta: [pageX - mx, pageY - my],
                    isMoved: true
                });
                _this.dragItem();
            }
        };
        _this.handleMouseUp = function () {
            var isPressed = _this.state.isPressed;
            if (isPressed) {
                _this.setState({
                    isPressed: false
                });
            }
        };
        var children = _this.props.children;
        var newChildren = Array.isArray(children) ? children.slice() : [children];
        _this.state = {
            mouseStart: [0, 0],
            mouseXY: [0, 0],
            mouseDelta: [0, 0],
            isMoved: false,
            isPressed: false,
            style: {
                transformX: 0,
                transformY: 0
            },
            items: newChildren.map(function (_) {
                return {
                    transformX: 0,
                    transformY: 0
                };
            }),
            children: newChildren
        };
        return _this;
    }
    StaggeredList.prototype.componentDidMount = function () {
        window.addEventListener('mousemove', this.handleMouseMove);
        window.addEventListener('mouseup', this.handleMouseUp);
    };
    StaggeredList.prototype.componentWillUnmount = function () {
        window.removeEventListener('mousemove', this.handleMouseMove);
        window.removeEventListener('mouseup', this.handleMouseUp);
    };
    StaggeredList.prototype.render = function () {
        var _this = this;
        var _a = this.state, items = _a.items, children = _a.children;
        if (items.length < 2) {
            return children;
        }
        return (createElement(reactMotion_2, { defaultStyles: items, styles: this.getStyles }, function (items) {
            return (createElement(Fragment, null, items.map(function (_a, i) {
                var transformX = _a.transformX, transformY = _a.transformY;
                return (createElement("div", { key: i, style: {
                        transform: "translate3d(" + transformX + "px, " + transformY + "px, 0)"
                    }, onMouseDown: function (e) {
                        i === 0 && _this.handleMouseDown(e);
                    }, onClickCapture: function (e) {
                        i === 0 && _this.handleClick(e);
                    } }, children[i]));
            })));
        }));
    };
    return StaggeredList;
}(Component));

__$styleInject("._window-wrapper_kk89t_1 {\n  position: absolute;\n  z-index: 9999;\n  top: 0;\n  left: 0;\n}\n\n._window-wrapper_kk89t_1 ._window_kk89t_1 {\n  position: absolute;\n}\n\n._window-wrapper_kk89t_1 ._resizable_kk89t_12 {\n  position: absolute;\n  list-style: none;\n  padding: 0;\n  margin: 0;\n  display: flex;\n  flex-wrap: wrap;\n}\n\n._window-wrapper_kk89t_1 ._resizable_kk89t_12 li {\n  margin: 0 !important;\n  padding: 0 !important;\n  float: inherit;\n}\n\n._window-wrapper_kk89t_1 ._resizable_kk89t_12 ._ns_kk89t_27 {\n  cursor: ns-resize;\n  z-index: 9999;\n}\n\n._window-wrapper_kk89t_1 ._resizable_kk89t_12 ._ew_kk89t_32 {\n  cursor: ew-resize;\n  z-index: 9999;\n}\n\n._window-wrapper_kk89t_1 ._resizable_kk89t_12 ._nwse_kk89t_37 {\n  cursor: nwse-resize;\n  z-index: 9999;\n}\n\n._window-wrapper_kk89t_1 ._resizable_kk89t_12 ._nesw_kk89t_42 {\n  cursor: nesw-resize;\n  z-index: 9999;\n}\n\n._window-wrapper_kk89t_1 ._titlebar_kk89t_47 {\n  background: whitesmoke;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n}\n\n._window-wrapper_kk89t_1 ._titlebar_kk89t_47 h4 {\n  flex-grow: 1;\n  margin: 0;\n}\n\n._window-wrapper_kk89t_1 ._titlebar_kk89t_47 button {\n  width: 10px;\n  height: 10px;\n  border-radius: 5px;\n}\n\n._window-wrapper_kk89t_1 ._titlebar_kk89t_47 button._resize_kk89t_65 {\n  background: green;\n}\n\n._window-wrapper_kk89t_1 ._titlebar_kk89t_47 button._close_kk89t_69 {\n  background: red;\n}\n", {});
var styles$2 = {"windowWrapper":"_window-wrapper_kk89t_1","window":"_window_kk89t_1","resizable":"_resizable_kk89t_12","ns":"_ns_kk89t_27","ew":"_ew_kk89t_32","nwse":"_nwse_kk89t_37","nesw":"_nesw_kk89t_42","titlebar":"_titlebar_kk89t_47","resize":"_resize_kk89t_65","close":"_close_kk89t_69"};

var Resizable = /** @class */ (function (_super) {
    __extends(Resizable, _super);
    function Resizable() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            size: 10
        };
        return _this;
    }
    Resizable.prototype.componentDidMount = function () {
        var _a = this.props, resizableMouseMove = _a.resizableMouseMove, resizableMouseUp = _a.resizableMouseUp;
        window.addEventListener('mousemove', resizableMouseMove);
        window.addEventListener('mouseup', resizableMouseUp);
    };
    Resizable.prototype.componentWillUnmount = function () {
        var _a = this.props, resizableMouseMove = _a.resizableMouseMove, resizableMouseUp = _a.resizableMouseUp;
        window.removeEventListener('mousemove', resizableMouseMove);
        window.removeEventListener('mouseup', resizableMouseUp);
    };
    Resizable.prototype.render = function () {
        var _a = this.props, width = _a.width, height = _a.height, cells = _a.cells, resize = _a.resize, resizable = _a.resizable, resizableMouseDown = _a.resizableMouseDown, resizableDoubleClick = _a.resizableDoubleClick;
        var position = resizable.position, show = resizable.show;
        var _b = cells[0], cell = _b === void 0 ? { top: 0, left: 0 } : _b;
        var top = cell.top, left = cell.left;
        var size = this.state.size;
        if (!resize) {
            return null;
        }
        if (!show) {
            return null;
        }
        return (createElement("ul", { className: styles$2.resizable, style: {
                top: top + position.top + -size / 2,
                left: left + position.left + -size / 2,
                width: width + size - position.left + position.right,
                height: height + size - position.top + position.bottom
            } },
            createElement("li", { className: styles$2.nwse, style: {
                    width: size / 2,
                    height: size / 2
                }, onMouseDown: function (e) {
                    resizableMouseDown({ e: e, type: 'leftTop' });
                } }),
            createElement("li", { className: styles$2.ns, style: {
                    width: width - position.left + position.right,
                    height: size / 2
                }, onMouseDown: function (e) {
                    resizableMouseDown({ e: e, type: 'top' });
                }, onDoubleClick: function (e) {
                    resizableDoubleClick({ e: e, direction: 'top' });
                } }),
            createElement("li", { className: styles$2.nesw, style: {
                    width: size / 2,
                    height: size / 2
                }, onMouseDown: function (e) {
                    resizableMouseDown({ e: e, type: 'rightTop' });
                } }),
            createElement("li", { className: styles$2.ew, style: {
                    width: size / 2,
                    height: height - position.top + position.bottom
                }, onMouseDown: function (e) {
                    resizableMouseDown({ e: e, type: 'left' });
                }, onDoubleClick: function (e) {
                    resizableDoubleClick({ e: e, direction: 'left' });
                } }),
            createElement("li", { style: {
                    width: width - position.left + position.right,
                    height: height - position.top + position.bottom
                } }),
            createElement("li", { className: styles$2.ew, style: {
                    width: size / 2,
                    height: height - position.top + position.bottom
                }, onMouseDown: function (e) {
                    resizableMouseDown({ e: e, type: 'right' });
                }, onDoubleClick: function (e) {
                    resizableDoubleClick({ e: e, direction: 'right' });
                } }),
            createElement("li", { className: styles$2.nesw, style: {
                    width: size / 2,
                    height: size / 2
                }, onMouseDown: function (e) {
                    resizableMouseDown({ e: e, type: 'leftBottom' });
                } }),
            createElement("li", { className: styles$2.ns, style: {
                    width: width - position.left + position.right,
                    height: size / 2
                }, onMouseDown: function (e) {
                    resizableMouseDown({ e: e, type: 'bottom' });
                }, onDoubleClick: function (e) {
                    resizableDoubleClick({ e: e, direction: 'bottom' });
                } }),
            createElement("li", { className: styles$2.nwse, style: {
                    width: size / 2,
                    height: size / 2
                }, onMouseDown: function (e) {
                    resizableMouseDown({ e: e, type: 'rightBottom' });
                } })));
    };
    return Resizable;
}(Component));

var TitleBar = /** @class */ (function (_super) {
    __extends(TitleBar, _super);
    function TitleBar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TitleBar.prototype.render = function () {
        var _a = this.props, titlebar = _a.titlebar, width = _a.width, toggleWindowSize = _a.toggleWindowSize, handleMouseDown = _a.handleMouseDown, removeWindow = _a.removeWindow, isFulling = _a.isFulling;
        if (!titlebar.use) {
            return null;
        }
        if (titlebar.component) {
            return (createElement(titlebar.component, { width: width, height: titlebar.height, title: titlebar.title, toggleWindowSize: toggleWindowSize, handleMouseDown: handleMouseDown, removeWindow: removeWindow, isFulling: isFulling() }));
        }
        return (createElement("div", { className: styles$2.titlebar, style: {
                width: width,
                height: titlebar.height
            } },
            createElement("h4", { onDoubleClick: toggleWindowSize, onMouseDown: handleMouseDown }, titlebar.title),
            createElement("button", { className: styles$2.resize, onClick: toggleWindowSize }),
            createElement("button", { className: styles$2.close, onClick: removeWindow })));
    };
    return TitleBar;
}(Component));

var Contents = /** @class */ (function (_super) {
    __extends(Contents, _super);
    function Contents() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Contents.prototype.render = function () {
        var _a = this.props, titlebar = _a.titlebar, width = _a.width, height = _a.height, children = _a.children;
        return (createElement("div", { style: {
                width: width,
                height: titlebar.use ? height - titlebar.height : height
            } }, children));
    };
    return Contents;
}(Component));

var lodash = require('lodash');
var getDirection = function (nextProps) {
    var width = nextProps.width, height = nextProps.height, position = nextProps.position, direction = nextProps.direction;
    var innerHeight = window.innerHeight, innerWidth = window.innerWidth;
    var top = 0;
    var left = 0;
    switch (direction) {
        case 'top':
            if (position.includes('top')) {
                top = innerHeight;
            }
            if (position.includes('left') || position.includes('right')) {
                top = innerHeight / 2 + height / 2;
            }
            if (position.includes('bottom')) {
                top = height;
            }
            break;
        case 'left':
            if (position.includes('top') || position.includes('bottom')) {
                left = innerWidth / 2 + width / 2;
            }
            if (position.includes('left')) {
                left = innerWidth;
            }
            if (position.includes('right')) {
                left = width;
            }
            break;
        case 'right':
            if (position.includes('top') || position.includes('bottom')) {
                left = -(innerWidth / 2 + width / 2);
            }
            if (position.includes('left')) {
                left = -width;
            }
            if (position.includes('right')) {
                left = -innerWidth;
            }
            break;
        case 'bottom':
            if (position.includes('top')) {
                top = -height;
            }
            if (position.includes('left') || position.includes('right')) {
                top = -(innerHeight / 2 + height / 2);
            }
            if (position.includes('bottom')) {
                top = -innerHeight;
            }
            break;
        default:
            break;
    }
    return {
        top: top,
        left: left
    };
};
var addWindow = function (nextProps, prevState) {
    return {
        wrapper: __assign({}, prevState.wrapper, { show: true }),
        cell: __assign({}, prevState.cell, getDirection(nextProps)),
        resizable: __assign({}, prevState.resizable, { show: true }),
        cells: [
            {
                top: 0,
                left: 0
            }
        ]
    };
};
var removeWindow = function (prevState) {
    var width = prevState.width, height = prevState.height, wrapper = prevState.wrapper, resizable = prevState.resizable;
    return {
        wrapper: __assign({}, wrapper, { isFull: false, width: width,
            height: height }),
        resizable: __assign({}, resizable, { show: false, position: {
                top: 0,
                left: 0,
                right: 0,
                bottom: 0
            }, prevMoveX: 0, prevMoveY: 0 }),
        cells: []
    };
};
var Window = /** @class */ (function (_super) {
    __extends(Window, _super);
    function Window(props) {
        var _this = _super.call(this, props) || this;
        _this.debounceWrapperSize = lodash.debounce(function () {
            var wrapper = _this.state.wrapper;
            _this.setState({
                wrapper: __assign({}, wrapper, _this.getPosition({ isFull: wrapper.isFull }))
            });
            _this.updateWrapperSize();
        }, 100);
        _this.updateWrapperSize = function () {
            var wrapper = _this.state.wrapper;
            var isFull = wrapper.isFull;
            var innerWidth = window.innerWidth, innerHeight = window.innerHeight;
            if (isFull) {
                _this.setState({
                    wrapper: __assign({}, wrapper, { width: innerWidth, height: innerHeight })
                });
            }
        };
        _this.getPosition = function (params) {
            var isFull = params.isFull;
            var _a = _this.props, width = _a.width, height = _a.height, position = _a.position;
            var innerHeight = window.innerHeight, innerWidth = window.innerWidth;
            var top = 0;
            var left = 0;
            if (isFull) {
                return {
                    top: top,
                    left: left
                };
            }
            switch (position) {
                case 'top':
                    left = innerWidth / 2 - width / 2;
                    break;
                case 'left':
                    top = innerHeight / 2 - height / 2;
                    break;
                case 'right':
                    top = innerHeight / 2 - height / 2;
                    left = innerWidth - width;
                    break;
                case 'bottom':
                    top = innerHeight - height;
                    left = innerWidth / 2 - width / 2;
                    break;
                default:
                    break;
            }
            return {
                top: top,
                left: left
            };
        };
        _this.isShowing = function () {
            return _this.state.wrapper.show;
        };
        _this.isFulling = function () {
            return _this.state.wrapper.isFull;
        };
        _this.removeWindow = function () {
            _this.setState(removeWindow(_this.state));
        };
        _this.toggleWindowSize = function () {
            var innerWidth = window.innerWidth, innerHeight = window.innerHeight;
            var _a = _this.state, width = _a.width, height = _a.height, wrapper = _a.wrapper, cells = _a.cells, cell = _a.cell, resizable = _a.resizable;
            var currentCell = cells[0];
            _this.setState({
                wrapper: __assign({}, wrapper, _this.getPosition({ isFull: !wrapper.isFull }), { isFull: !wrapper.isFull, width: wrapper.isFull ? width : innerWidth, height: wrapper.isFull ? height : innerHeight }),
                resizable: __assign({}, resizable),
                cell: __assign({}, cell, { prevTop: currentCell.top, prevLeft: currentCell.left }),
                cells: cells.map(function (_) {
                    return {
                        top: wrapper.isFull ? cell.prevTop : 0,
                        left: wrapper.isFull ? cell.prevLeft : 0
                    };
                })
            });
        };
        _this.willEnter = function () {
            return __assign({}, _this.state.cell);
        };
        _this.willLeave = function () {
            var cell = _this.state.cell;
            return {
                top: reactMotion_4(cell.top),
                left: reactMotion_4(cell.left)
            };
        };
        _this.didLeave = function () {
            var _a = _this.props.onClose, onClose = _a === void 0 ? function () { } : _a;
            _this.setState(function (prevState) {
                return {
                    wrapper: __assign({}, prevState.wrapper, { show: false })
                };
            }, function () {
                onClose();
            });
        };
        _this.handleMouseDown = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            var wrapper = _this.state.wrapper;
            _this.setState({
                wrapper: __assign({}, wrapper, { isPressed: true, isMoved: false, mouseDelta: [pageX, pageY], mouseXY: [pageX, pageY] })
            });
            e.preventDefault();
        };
        _this.handleMouseMove = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            var wrapper = _this.state.wrapper;
            var _a = document.body, scrollWidth = _a.scrollWidth, scrollHeight = _a.scrollHeight;
            var isPressed = wrapper.isPressed, _b = wrapper.mouseXY, mx = _b[0], my = _b[1], isFull = wrapper.isFull;
            if (isFull) {
                return;
            }
            if (pageX < 0 || pageY < 0) {
                return;
            }
            if (pageX > scrollWidth || pageY > scrollHeight) {
                return;
            }
            if (isPressed) {
                _this.setState({
                    wrapper: __assign({}, wrapper, { mouseXY: [pageX, pageY], mouseDelta: [pageX - mx, pageY - my], isMoved: true })
                });
                _this.dragWindow();
            }
        };
        _this.dragWindow = function () {
            var _a = _this.state, wrapper = _a.wrapper, cells = _a.cells;
            var _b = wrapper.mouseDelta, dx = _b[0], dy = _b[1];
            var newCells = cells.concat();
            newCells = newCells.map(function (cell) {
                return {
                    top: cell.top + dy,
                    left: cell.left + dx
                };
            });
            _this.setState({
                cells: newCells
            });
        };
        _this.handleMouseUp = function () {
            var wrapper = _this.state.wrapper;
            var isPressed = wrapper.isPressed;
            if (isPressed) {
                _this.setState({
                    wrapper: __assign({}, wrapper, { isPressed: false })
                });
            }
        };
        _this.resizableMouseDown = function (params) {
            var e = params.e, type = params.type;
            var resizable = _this.state.resizable;
            var pageX = e.pageX, pageY = e.pageY, target = e.target;
            _this.setState({
                resizable: __assign({}, resizable, { type: type, isPressed: true, isMoved: false, shiftXY: [
                        target.getBoundingClientRect().left - resizable.position.left,
                        target.getBoundingClientRect().top - resizable.position.top
                    ], mouseDelta: [
                        pageX - target.getBoundingClientRect().left,
                        pageY - target.getBoundingClientRect().top
                    ], mouseXY: [pageX, pageY] })
            });
            e.preventDefault();
        };
        _this.resizableMouseMove = function (e) {
            var pageX = e.pageX, pageY = e.pageY;
            var _a = _this.state, wrapper = _a.wrapper, resizable = _a.resizable;
            var isFull = wrapper.isFull;
            var isPressed = resizable.isPressed;
            var _b = document.body, scrollWidth = _b.scrollWidth, scrollHeight = _b.scrollHeight;
            if (isFull) {
                return;
            }
            if (pageX < 0 || pageY < 0) {
                return;
            }
            if (pageX > scrollWidth || pageY > scrollHeight) {
                return;
            }
            if (isPressed) {
                _this.setState({
                    resizable: __assign({}, resizable, { mouseXY: [pageX, pageY], isMoved: true })
                });
                _this.resizableWindow(e);
            }
        };
        _this.resizableWindow = function (_e) {
            var _a = _this.props, minWidth = _a.minWidth, minHeight = _a.minHeight;
            var _b = _this.state, resizable = _b.resizable, wrapper = _b.wrapper;
            var shiftXY = resizable.shiftXY, mouseXY = resizable.mouseXY, mouseDelta = resizable.mouseDelta, type = resizable.type, position = resizable.position, prevMoveX = resizable.prevMoveX, prevMoveY = resizable.prevMoveY;
            var mx = mouseXY[0], my = mouseXY[1];
            var sx = shiftXY[0], sy = shiftXY[1];
            var dx = mouseDelta[0], dy = mouseDelta[1];
            var resizeTop = position.top;
            var resizeLeft = position.left;
            var resizeRight = position.right;
            var resizeBottom = position.bottom;
            switch (type) {
                case 'top':
                    resizeTop = my - sy - dy;
                    if (minHeight > wrapper.height - (resizeTop - resizeBottom)) {
                        resizeTop = resizeBottom;
                    }
                    break;
                case 'leftTop':
                    resizeTop = my - sy - dy;
                    resizeLeft = mx - sx - dx;
                    if (minWidth > wrapper.width - (resizeLeft - resizeRight)) {
                        resizeLeft = resizeRight;
                    }
                    if (minHeight > wrapper.height - (resizeTop - resizeBottom)) {
                        resizeTop = resizeBottom;
                    }
                    break;
                case 'rightTop':
                    resizeRight = mx - sx - dx + prevMoveX;
                    resizeTop = my - sy - dy;
                    if (minWidth > wrapper.width - (resizeLeft - resizeRight)) {
                        resizeRight = resizeLeft;
                    }
                    if (minHeight > wrapper.height - (resizeTop - resizeBottom)) {
                        resizeTop = resizeBottom;
                    }
                    break;
                case 'left':
                    resizeLeft = mx - sx - dx;
                    if (minWidth > wrapper.width - (resizeLeft - resizeRight)) {
                        resizeLeft = resizeRight;
                    }
                    break;
                case 'right':
                    resizeRight = mx - sx - dx + prevMoveX;
                    if (minWidth > wrapper.width - (resizeLeft - resizeRight)) {
                        resizeRight = resizeLeft;
                    }
                    break;
                case 'leftBottom':
                    resizeLeft = mx - sx - dx;
                    resizeBottom = my - sy - dy + prevMoveY;
                    if (minWidth > wrapper.width - (resizeLeft - resizeRight)) {
                        resizeLeft = resizeRight;
                    }
                    if (minHeight > wrapper.height - (resizeTop - resizeBottom)) {
                        resizeBottom = resizeTop;
                    }
                    break;
                case 'bottom':
                    resizeBottom = my - sy - dy + prevMoveY;
                    if (minHeight > wrapper.height - (resizeTop - resizeBottom)) {
                        resizeBottom = resizeTop;
                    }
                    break;
                case 'rightBottom':
                    resizeRight = mx - sx - dx + prevMoveX;
                    resizeBottom = my - sy - dy + prevMoveY;
                    if (minWidth > wrapper.width - (resizeLeft - resizeRight)) {
                        resizeRight = resizeLeft;
                    }
                    if (minHeight > wrapper.height - (resizeTop - resizeBottom)) {
                        resizeBottom = resizeTop;
                    }
                    break;
                default:
                    break;
            }
            _this.setState({
                resizable: __assign({}, resizable, { position: {
                        top: resizeTop,
                        left: resizeLeft,
                        right: resizeRight,
                        bottom: resizeBottom
                    } })
            });
        };
        _this.resizableMouseUp = function () {
            var resizable = _this.state.resizable;
            var isPressed = resizable.isPressed, position = resizable.position;
            if (isPressed) {
                _this.setState({
                    resizable: __assign({}, resizable, { isPressed: false, prevMoveX: -position.left + position.right, prevMoveY: -position.top + position.bottom })
                });
            }
        };
        _this.resizableDoubleClick = function (params) {
            var e = params.e, direction = params.direction;
            _this.stickyWindow({ e: e, direction: direction });
        };
        _this.stickyWindow = function (params) {
            var e = params.e, direction = params.direction;
            var resizable = _this.state.resizable;
            var position = resizable.position;
            var innerWidth = window.innerWidth, innerHeight = window.innerHeight;
            var rectTop = e.target.getBoundingClientRect().top;
            var rectLeft = e.target.getBoundingClientRect().left;
            var stickyTop = position.top;
            var stickyLeft = position.left;
            var stickyRight = position.right;
            var stickyBottom = position.bottom;
            switch (direction) {
                case 'top':
                    stickyTop += -rectTop - 5;
                    break;
                case 'left':
                    stickyLeft += -rectLeft - 5;
                    break;
                case 'right':
                    stickyRight += innerWidth - rectLeft;
                    break;
                case 'bottom':
                    stickyBottom += innerHeight - rectTop;
                    break;
                default:
                    break;
            }
            _this.setState({
                resizable: __assign({}, resizable, { position: __assign({}, resizable.position, { top: stickyTop, left: stickyLeft, right: stickyRight, bottom: stickyBottom }) })
            });
        };
        _this.state = {
            open: false,
            width: 0,
            height: 0,
            wrapper: {
                top: 0,
                left: 0,
                isFull: false,
                show: false,
                width: 0,
                height: 0,
                isMoved: false,
                isPressed: false,
                mouseXY: [0, 0],
                mouseDelta: [0, 0]
            },
            cell: {
                top: 0,
                left: 0,
                prevTop: 0,
                prevLeft: 0
            },
            cells: [],
            titlebar: {
                use: false,
                title: '',
                component: null,
                height: 30
            },
            resizable: {
                show: false,
                type: 'top',
                isMoved: false,
                isPressed: false,
                mouseXY: [0, 0],
                mouseDelta: [0, 0],
                shiftXY: [0, 0],
                position: { top: 0, left: 0, right: 0, bottom: 0 },
                prevMoveX: 0,
                prevMoveY: 0
            }
        };
        return _this;
    }
    Window.getDerivedStateFromProps = function (nextProps, prevState) {
        if (nextProps.open !== prevState.open) {
            var state = nextProps.open
                ? addWindow(nextProps, prevState)
                : removeWindow(prevState);
            return __assign({}, prevState, state, { open: nextProps.open });
        }
        return null;
    };
    Window.prototype.componentDidMount = function () {
        var _this = this;
        var _a = this.props, open = _a.open, width = _a.width, height = _a.height, titlebar = _a.titlebar;
        window.addEventListener('mousemove', this.handleMouseMove);
        window.addEventListener('mouseup', this.handleMouseUp);
        window.addEventListener('resize', this.debounceWrapperSize);
        this.setState(function (prevState) {
            return {
                open: open,
                width: width,
                height: height,
                wrapper: __assign({}, prevState.wrapper, _this.getPosition({ isFull: false }), { width: width,
                    height: height }),
                titlebar: __assign({}, prevState.titlebar, titlebar)
            };
        });
    };
    Window.prototype.componentWillUnmount = function () {
        window.removeEventListener('mousemove', this.handleMouseMove);
        window.removeEventListener('mouseup', this.handleMouseUp);
        window.removeEventListener('resize', this.debounceWrapperSize);
    };
    Window.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, _b = _a.resize, resize = _b === void 0 ? false : _b;
        var _c = this.state, titlebar = _c.titlebar, wrapper = _c.wrapper, resizable = _c.resizable;
        var resizeCells = this.state.cells.map(function (cell) {
            var top = cell.top, left = cell.left;
            if (wrapper.isFull) {
                return {
                    top: top - resizable.position.top,
                    left: left - resizable.position.left
                };
            }
            return { top: top, left: left };
        });
        var resizeWidth = wrapper.isFull
            ? wrapper.width + (resizable.position.left - resizable.position.right)
            : wrapper.width;
        var resizeHeight = wrapper.isFull
            ? wrapper.height + (resizable.position.top - resizable.position.bottom)
            : wrapper.height;
        return (createElement(reactMotion_1, { style: {
                left: reactMotion_4(wrapper.isFull ? 0 : resizable.position.left),
                top: reactMotion_4(wrapper.isFull ? 0 : resizable.position.top),
                width: reactMotion_4(wrapper.isFull
                    ? wrapper.width
                    : wrapper.width + resizable.position.right),
                height: reactMotion_4(wrapper.isFull
                    ? wrapper.height
                    : wrapper.height + resizable.position.bottom),
                wrapperTop: reactMotion_4(wrapper.top),
                wrapperLeft: reactMotion_4(wrapper.left)
            } }, function (_a) {
            var top = _a.top, left = _a.left, width = _a.width, height = _a.height, wrapperTop = _a.wrapperTop, wrapperLeft = _a.wrapperLeft;
            return (createElement("div", { className: "" + styles$2.windowWrapper, style: {
                    top: wrapperTop,
                    left: wrapperLeft,
                    visibility: wrapper.show ? 'visible' : 'hidden'
                } },
                createElement(Resizable, { width: resizeWidth, height: resizeHeight, cells: resizeCells, resize: resize, resizable: resizable, resizableMouseDown: _this.resizableMouseDown, resizableMouseMove: _this.resizableMouseMove, resizableMouseUp: _this.resizableMouseUp, resizableDoubleClick: _this.resizableDoubleClick }),
                createElement(reactMotion_3, { willEnter: _this.willEnter, willLeave: _this.willLeave, didLeave: _this.didLeave, styles: _this.state.cells.map(function (cell, i) {
                        var top = cell.top, left = cell.left;
                        return {
                            key: "" + i,
                            style: {
                                top: reactMotion_4(top),
                                left: reactMotion_4(left)
                            }
                        };
                    }) }, function (cells) { return (createElement(Fragment, null, cells.map(function (cell) {
                    return (createElement("div", { key: cell.key, className: styles$2.window, style: {
                            top: cell.style.top + top,
                            left: cell.style.left + left,
                            width: width - left,
                            height: height - top
                        } },
                        createElement(TitleBar, { titlebar: titlebar, width: width - left, isFulling: _this.isFulling, toggleWindowSize: _this.toggleWindowSize, handleMouseDown: _this.handleMouseDown, removeWindow: _this.removeWindow }),
                        createElement(Contents, { titlebar: titlebar, width: width - left, height: height - top, children: children })));
                }))); })));
        }));
    };
    return Window;
}(Component));

export { Carousel, Cube, DraggableList, StaggeredList, Window };
//# sourceMappingURL=index.es.js.map
